const debug = false;

if (typeof browser === 'undefined')
    browser = chrome;

const TestEnv = {
    'backensterKey': '8b68e2e73e27ad625f197c74e4403c716f1854e8',
    'piwikSiteId': 0,
    'rateUrl': ''
};

const FirefoxEnv = {
    'backensterKey': '78f54c05e71da015bdc316d03d10f30f17bf4d49',
    'piwikSiteId': 16,
    'rateUrl': 'https://addons.mozilla.org/firefox/addon/lingvanex-translator/'
};

const OperaEnv = {
    'backensterKey': 'eb86e2d781c5948db8d2b28762de789ebe7574ca',
    'piwikSiteId': 17,
    'rateUrl': 'https://addons.opera.com/extensions/details/lingvanex-translator-and-dictionary/'
};

const ChromeEnv = {
    'backensterKey': '09c0217b8ff14da927ab7556b7e2aa5e42a0b0d9',
    'piwikSiteId': 18,
    'rateUrl': 'https://chrome.google.com/webstore/detail/lingvanex-translator/kdamfjkjgaidaigdfelkpgdnbigclccc/reviews'
};

const EdgeEnv = {
    'backensterKey': 'a65279118f11c96516d185a999617fd8124bbfc1',
    'piwikSiteId': 75,
    'rateUrl': 'https://microsoftedge.microsoft.com/addons/detail/pppgidljpojmcjehgdnfmmffbhifdloh'
};

window.LingvanexEnv = getEnv();

function detectBrowser() {
    try {
        // Firefox 1.0+
        if (typeof InstallTrigger !== 'undefined' || navigator.userAgent.indexOf(' Firefox/') >= 0)
            return 'Firefox';
        // Opera 8.0+
        if ((!!window.opr && !!opr.addons) || !!window.opera || navigator.userAgent.indexOf(' OPR/') >= 0)
            return 'Opera';
        // Edge
        if (navigator.userAgent.indexOf('Edg') > -1 || navigator.userAgent.indexOf('Edge') > -1)
            return 'Edge';
    } catch (e) {
        console.exception(e);
    }
    // Everything else
    return 'Chrome'
}

function getEnv() {
    console.log('Load env');
    if (debug)
        return TestEnv;

    switch (detectBrowser()) {
        case "Firefox":
            return FirefoxEnv;
        case "Opera":
            return OperaEnv;
        case "Edge":
            return EdgeEnv;
        case "Chrome":
            return ChromeEnv;
        default:
            console.error('Unsupported browser')
    }
}

function debug_log(message) {
    if (debug){
        console.log(message)
    }
}
