﻿let siteDomain = "https://lingvanex.com/";
let piwik_idts;
let piwik_idvc;
let piwik_cvar;
let piwik_uuid;
chrome = chrome || browser;


let OSName = "Unknown";
if (window.navigator.userAgent.indexOf("Windows NT 10.0") !== -1) OSName = "Windows 10";
if (window.navigator.userAgent.indexOf("Windows NT 6.2") !== -1) OSName = "Windows 8";
if (window.navigator.userAgent.indexOf("Windows NT 6.1") !== -1) OSName = "Windows 7";
if (window.navigator.userAgent.indexOf("Windows NT 6.0") !== -1) OSName = "Windows Vista";
if (window.navigator.userAgent.indexOf("Windows NT 5.1") !== -1) OSName = "Windows XP";
if (window.navigator.userAgent.indexOf("Windows NT 5.0") !== -1) OSName = "Windows 2000";
if (window.navigator.userAgent.indexOf("Mac") !== -1) OSName = "Mac/iOS";
if (window.navigator.userAgent.indexOf("X11") !== -1) OSName = "UNIX";
if (window.navigator.userAgent.indexOf("Linux") !== -1) OSName = "Linux";

let _paq = [];
_paq.push(['setCustomVariable',
    1,
    "Visitor",
    "myfile",
    "page"
]);


//load piwik variables
function loadPiwikVars(callback) {
    try {
        let browserStorage = chrome.storage.local || chrome.storage.sync;


        browserStorage.get(['lingvanex_uuid', 'id', 'userLogged'], function ({lingvanex_uuid, id, userLogged}) {

            if (!chrome.runtime.error) {
                piwik_uuid = userLogged ? id : lingvanex_uuid;
                //console.log(lingvanex_uuid + " piwik_uuid read");
            }

            browserStorage.get('piwik_idvc', function (obj) {
                if (!chrome.runtime.error) {
                    piwik_idvc = obj.piwik_idvc;
                }
                if (!piwik_idvc) {
                    piwik_idvc = 0;
                }
                piwik_idvc++;
                browserStorage.set({'piwik_idvc': piwik_idvc}, function () {
                    //console.log(piwik_idvc + " piwik_idvc saved");
                });

                browserStorage.get('piwik_idts', function (obj) {
                    if (!chrome.runtime.error) {
                        piwik_idts = obj.piwik_idts;
                    }
                    if (!piwik_idts) {
                        piwik_idts = Date.now();
                        browserStorage.set({'piwik_idts': piwik_idts}, function () {
                            //console.log(piwik_idts + " piwik_idts saved");
                        });
                    }

                    if (callback)
                        callback();
                });
            });
        });
    } catch (ex) {
        console.log(`piwik vars error: ${ex.name}, ${ex.message}, ${ex.stack}`);
    }
}

//track extension action
function piwikTrackEvent(category, action, properties) {
    //console.info(`trackEvent category: "${category}"  action: "${action}" ${properties}`);

    // Properties example [language_from: English , language_to: German]
    let propertiesArray = ' [ ';
    for (let key in properties) {
        if (Object.keys(properties)[Object.keys(properties).length - 1] === key) {
            propertiesArray += key + ": " + properties[key] + ' ] '
        } else {
            propertiesArray += key + ": " + properties[key] + ' , '
        }
    }
    chrome.storage.local.get(['langSrc', 'langDst', 'lingvanex_uuid', 'id', 'email', 'userLogged', 'username',
        'voiceGender', 'allowSentenceAuto', 'allowWordAuto', 'showTranslateIcon', 'showSpeakIcon', 'speedOfText'], function (config) {

        let defaultObj = {
            language_from: config.langSrc,
            language_to: config.langDst
        };

        let defaultObjText = ' [ ';
        for (let key in defaultObj) {

            if (Object.keys(defaultObj)[Object.keys(defaultObj).length - 1] === key) {
                defaultObjText += key + ": " + defaultObj[key] + ' ] '
            } else {
                defaultObjText += key + ": " + defaultObj[key] + ' , '
            }
        }

        let nameWithProperties = `Properties ${propertiesArray}`;

        try {
            let manifestData = chrome.runtime.getManifest();

            let cvar = {
                "1": ["os_version", window.navigator.userAgent],
                "2": ["app_version", manifestData.version],
                "3": ["voice_sex", config.voiceGender],
                "4": ["phrase_translator", config.allowSentenceAuto],
                "5": ["word_traslator", config.allowWordAuto],
                "6": ["language_to", config.langDst],
                "7": ["language_from", config.langSrc],
                "8": ["voice_speed", config.speedOfText],
                "9": ["system_language", navigator.language || navigator.userLanguage],
                "10": ["platform", OSName],
                "11": ["user_id", config.lingvanex_uuid],
                "13": ["email", config.email],
                "14": ["lingvanex_id", config.id],
                "15": ["translate_icon", config.showTranslateIcon],
                "16": ["speak_icon", config.showSpeakIcon],
            };

            piwik_clet = JSON.stringify(cvar);

            let random = randomIntFromInterval(1, 999999);
            //let encodedUrl = encodeURI(siteDomain + pageName);
            let piwik_data = {
                idsite: window.LingvanexEnv.piwikSiteId,
                rec: 1,
                apiv: 1,
                r: random,
                uid: piwik_uuid,
                _idts: piwik_idts,
                _idvc: piwik_idvc,
                _cvar: piwik_cvar,
                e_c: encodeURI(category),
                e_a: encodeURI(action),
                e_n: encodeURI(properties ? nameWithProperties : defaultObjText)
                //url: encodedUrl,
                //action_name: pageName
            };

            $.ajax({
                type: 'post',
                timeout: 10000,
                //dataType: 'json',
                data: piwik_data,
                url: 'https://analytics.nordicwise.com/piwik.php',
                cache: false,
                success: function (response) {
                    if (response) {
                        //console.log("piwik success: " + response);
                    }
                },
                error: function (err) {
                    console.error(err.responseText);
                }
            });

        } catch (e) {
            console.log("piwik error: " + e);
        }

    });
}


//get random number
function randomIntFromInterval(min, max) {
    return Math.floor(Math.random() * (max - min + 1) + min);
}
