let PLATFORM_NAME = 'browserExtension';
let lingvanexUrl = 'https://lingvanex.com/';
let lexicalError = 'No data for this word';
let bookmarkError = 'No bookmark found'; // FIXME: Rename to bookmarkEmptyText
let historyEmptyText = 'History is empty';
let activeAdIndex = 0;
let autoDetectionText = 'Auto-Detection';
let FacebookOpenURL = 'https://www.facebook.com/Lingvanex-1984466758449759/';
let PrivacyOpenURL = 'https://lingvanex.com/en/privacy-policy/';
let TermsAndConditionsOpenURL = 'https://lingvanex.com/en/terms-of-service/';
let TwitterOpenURL = 'https://twitter.com/lingvanex';
let ThirdPartyOpenURL = 'https://lingvanex.com/';
let InstagramOpenURL = 'https://www.instagram.com/lingvanex/';
let LinkedinOpenURL = 'https://www.linkedin.com/company/lingvanex/';
let TelegramOpenURL = 'https://t.me/lingvanexbot?start=refbrowserExtension';
let areaSelectionHint = 'Please select area to translate';
let voiceErrorMsg = 'Error during voice loading';

const guidTranslate = 'c12b5a4e69860bc968b47223fd-';
const textareaFrom = $(`#${guidTranslate}inputText`);
let translationErrorMsg = 'translation error';

let isTranslating = false;
let backensterConfig;
let backensterMoreAppsURL = 'https://lingvanex.com/en/products/';
let backensterCharacterCountRequestLimitFree = 3000;
let backensterTTSRequestLimit = 3000;
let backensterAdChangeInterval = 4;
let backensterRatingTranslationEventCount = 3000;
let audio;
let uuidv;
let translateCount;
let translatorLink;

let lastRequestTime;

const soundActive = browser.extension.getURL('frame/Images/sound_active.png');
const soundInactive = browser.extension.getURL('frame/Images/sound.png');
const loader = browser.extension.getURL('frame/Images/spin.gif');

let lastTextOriginal = ''; // Used to translate the same text again after changing a language in the small popup
let lastTextTranslation = ''; // Used for text-to-speech feature

const logographicScripts = ['zh-Hant_TW', 'zh-Hans_CN', 'ko_KR', 'ja_JP'];


// #region Extensions
if (!String.prototype.trimBraces) {
    (function () {
        String.prototype.trimBraces = function () {
            return this.replace(/^[\s()]+|[\s()]+$/g, '');
        };
    })();
}

if (!String.prototype.splice) {
    /**
     * {JSDoc}
     *
     * The splice() method changes the content of a string by removing a range of
     * characters and/or adding new characters.
     *
     * @this {String}
     * @param {number} start Index at which to start changing the string.
     * @param {number} delCount An integer indicating the number of old chars to remove.
     * @param {string} newSubStr The String that is spliced in.
     * @return {string} A new string with the spliced substring.
     */
    String.prototype.splice = function (start, delCount, newSubStr) {
        return this.slice(0, start) + newSubStr + this.slice(start + Math.abs(delCount));
    };
}

if ($('body').hasClass(`${guidTranslate}lingvanex-popup`)) {
    analyticsTrackEvent('Main Popup', 'Show');

    browser.runtime.sendMessage({msg: 'popup-loaded'});
}

jQuery.fn.visible = function () {
    return this.css('visibility', 'visible');
};

jQuery.fn.invisible = function () {
    return this.css('visibility', 'hidden');
};


function getParentPopupByTarget(target) {
    return $($(target).closest(`#${guidTranslate}small-translator-div`)[0] ||
        $(target).closest(`#${guidTranslate}medium-translator-div`)[0] ||
        $(target).closest(`#${guidTranslate}translator-div-container`)[0]);
}

function getPopupNameById(id) {
    if (id === `${guidTranslate}small-translator-div`)
        return "Small Popup";
    if (id === `${guidTranslate}medium-translator-div`)
        return "Medium Popup";
    if (id === `${guidTranslate}translator-div-container`)
        return "Big Popup";
}

function getTemplate(path) {
    return new Promise(function (resolve) {
        $.ajax({
            url: browser.extension.getURL(path),
            success: function (data) {
                return resolve($.parseHTML(data));
            }
        });
    });
}

function resetPopupIcons() {
    $(`.${guidTranslate}ToDropArrow,.${guidTranslate}FromDropArrow`).removeClass(`${guidTranslate}arrowClosed`);
    //remove cloud arrow icon
    $(
        `.${guidTranslate}translator-list #${guidTranslate}from .${guidTranslate}country-flag,.${guidTranslate}translator-list #${guidTranslate}to .${guidTranslate}country-flag`
    ).removeClass(`${guidTranslate}showCloudArrow`);

    //remove active icon class from icons
    $(`.${guidTranslate}tab-container-icon`).each((index, element) => {
        $(element).removeClass(`${guidTranslate}activeSvg`);
    });
}

const trackTabSwitchingEvent = tabName => {
    let action = 'Show General panel';
    if (tabName === 'history') {
        action = 'Show History panel';
    } else if (tabName === 'vocabulary') {
        action = 'Show Dictionary panel';
    } else if (tabName === 'bookmark') {
        action = 'Show Bookmarks panel';
    } else if (tabName === 'settings') {
        action = 'Show Settings panel';
    }
    analyticsTrackEvent('Big Popup', action);
};

function hideLngList(){
    document.getElementById(`${guidTranslate}toListSelect`).style.display = 'none';
    document.getElementById(`${guidTranslate}listDiv`).style.display = 'none';
}

function onTabClick(e) {
    const tabName = $(e.target).closest(`.${guidTranslate}tab-container-item`).data('tab');
    showTabByName(tabName);
    //track event
    trackTabSwitchingEvent(tabName);
}

function showTabByName(tabName) {
    //reset extension icons after tab switching
    resetPopupIcons();

    //hideLngList
    hideLngList();

    if (tabName === 'settings') {
        //if setting change header an make height bigger
        $(`.${guidTranslate}translator-setting-headline`).show();
        $(`#${guidTranslate}regular-translator-header`).hide();
        $(`#${guidTranslate}setting-translator-header`).show();
        $(`#${guidTranslate}translator-div-container`).css({
            height: 574,
        });
    } else if (tabName === 'welcome') {
        //if setting change header an make height bigger
        $(`.${guidTranslate}translator-setting-headline`).hide();
        $(`#${guidTranslate}regular-translator-header`).hide();
        $(`#${guidTranslate}setting-translator-header`).show();
        $(`#${guidTranslate}translator-div-container`).css({
            height: 574,
        });
    } else {
        $(`#${guidTranslate}regular-translator-header`).show();
        $(`#${guidTranslate}setting-translator-header`).hide();
        $(`#${guidTranslate}translator-div-container`).css({
            height: '502px',
        });
    }

    //add active icon for selected tab
    $(`#${guidTranslate}${tabName}-img`).addClass(`${guidTranslate}activeSvg`);

    //hide previous tab
    $(`.${guidTranslate}extension-tabs`).each(function () {
        $(this).hide();
    });

    //show active tab
    $(`#${guidTranslate}${tabName}-tab`).show();
}

const ocrImageShowLoader = () => {
    // $(`#${guidTranslate}inputText`).val('');
    // $(`#${guidTranslate}outputText`).val('');
    // $(`#${guidTranslate}translator-div-container`).show();
    showBigPopup();

    $(`.${guidTranslate}bigTranslateModal`).prepend(`
                 <img class="${guidTranslate}imageloader-first"  src="${loader}" />
                 <img class="${guidTranslate}imageloader-second"  src="${loader}" />
            `);
};

const ocrImageHideLoader = () => {
    $(`.${guidTranslate}imageloader-first`).remove();
    $(`.${guidTranslate}imageloader-second`).remove();
};


// #region Initialization

const settingsTabsInitialize = () => {
    if (window.location.href.startsWith('https://accounts.google.com/') ||
        window.location.href.startsWith('https://console.firebase.google.com/') ||
        window.location.href.startsWith('https://console.cloud.google.com/')) // FIXME: Kostyl'
        return;

    $(`#${guidTranslate}tabs`).tabs({
        activate: function (event, ui) {
            let tabIndex = ui.newTab.index();
            let action = '';
            if (tabIndex === 0) {  // Main
                action = 'Show Main tab';
            } else if (tabIndex === 1) { // Account
                checkUserLogin();
                action = 'Show Account tab';
            } else if (tabIndex === 2) { // Info
                action = 'Show Info tab';
            } else if (tabIndex === 3) { // About
                action = 'Show About tab';
            }
            analyticsTrackEvent('Settings', action);
        },
    });
};

const textSpeedSliderInitialize = () => {
    let slideAnalytic;

    $(`#${guidTranslate}slider-range-min`).slider({
        range: 'min',
        value: 100,
        step: 10,
        min: 0,
        max: 200,
        slide: function (event, ui) {
            let valueOfSpeed = ui.value;

            if (valueOfSpeed < 20) {
                valueOfSpeed = 20;
            }

            clearTimeout(slideAnalytic);

            slideAnalytic = setTimeout(function () {
                analyticsTrackEvent('Settings', 'Change Voice Speed', {speed: valueOfSpeed});
            }, 1000);

            browser.storage.local.set({speedOfText: valueOfSpeed});
        },
    });
};

$(document).ready(async function () {
    settingsTabsInitialize();
    textSpeedSliderInitialize();
    getSettingsValues();
    handleTabsUpdate();

    try {
        let manifestData = browser.runtime.getManifest();
        $(`#${guidTranslate}aboutVersion`).html('Version&nbsp;' + manifestData.version);

        let textParam = null;

        initSmallLngList();

        // attachHandlers();

        $(`#${guidTranslate}inputText`).val(textParam);

        loadStorageVars(function () {
            browser.runtime.sendMessage({msg: 'load_popup_ended'});
            readBackensterParams(function () {
                //trackPageView("backensterParamsRead");
                initLangLists(function () {
                    // onPopupOpen();
                    attachHandlers();
                    showAdsBanner();
                    //translate();
                });
            });
        });
    } catch (ex) {
        console.error('init script error', ex);
    }
});

const getActiveWindow = () => {
    const smallWindow = $(`#${guidTranslate}small-translator-div`);
    const mediumWindow = $(`#${guidTranslate}medium-translator-div`);
    const bigModalWindow = $(`#${guidTranslate}translator-div-container`);

    if (smallWindow.is(':visible')) {
        return 'Word';
    } else if (mediumWindow.is(':visible')) {
        return 'Phrase';
    } else if (bigModalWindow.is(':visible')) {
        return 'Main';
    } else {
        return 'Main';
    }
};

const onPopupOpen = () => {
    if ($('body').hasClass(`${guidTranslate}lingvanex-popup`)) {
        browser.runtime.sendMessage({msg: 'popup-loaded'});

        trackEventWithLanguageData('Main(popup) screen', 'Shown');
    } else {
        trackEventWithLanguageData('Main screen', 'Shown');
    }
};

function loadStorageVars(callback) {
    browser.storage.local.get(['lingvanex_uuid', 'locales', 'appLng', 'justInstalled', 'analyticsEnabled'], function (config) {
        if (config.locales) {
            localesLng = config.locales;
            generateLocaliseSelect(config.locales);
            localize(config.appLng);
        }

        if (!browser.runtime.error) {
            uuidv = config.lingvanex_uuid;
        }
        if (config.justInstalled) {
            showTabByName('welcome');
        }
        $(`#${guidTranslate}analytics`).prop("checked", config.analyticsEnabled);
    });
    loadPiwikVars(callback);
    readTranslateCount();
}

const generateLocaliseSelect = locales => {
    debug_log('generateLocaliseSelect');

    browser.storage.local.get(['appLng', 'localeNames'], function ({appLng, localeNames}) {
        let selectContainer = $(`#${guidTranslate}change-ext-lng-btn`);
        selectContainer.empty();

        var locales_array = Object.keys(locales).map(function (key) {
            if (key in localeNames) {
                locales[key].languageNameText = localeNames[key][key]; // appLng
            }
            return [key, locales[key]];
        });

        // Sort the array based on the languageNameText
        locales_array = locales_array.sort(function (first, second) {
            return second[1].languageNameText < first[1].languageNameText;
        });

        for (let i in locales_array) {
            const lngShortCode = locales_array[i][0];
            const item = locales_array[i][1];
            const itemName = item.languageNameText || item.LanguageNameText || "Default";
            selectContainer.append(`<option value="${lngShortCode}">${itemName}</option>`);
        }
        selectContainer.val(appLng);
    });
};

function incrementTranslateCount() {
    translateCount++;
    browser.storage.local.set({lingvanexTranslateCount: translateCount});
}

function readTranslateCount() {
    browser.storage.local.get('lingvanexTranslateCount', function (obj) {
        if (!browser.runtime.error) {
            translateCount = obj.lingvanexTranslateCount;
        }
        if (!translateCount) {
            translateCount = 0;
        }
    });
}

function showAdsBanner(animate) {
    browser.storage.local.get(['addInfo'], function ({addInfo: banners}) {
        if (banners) {
            if (activeAdIndex >= banners.length) {
                activeAdIndex = 0;
            }

            const {adsUrl, assetUrl, description} = banners[activeAdIndex];

            $(`.${guidTranslate}moreAplacationText a`).attr("href", adsUrl);
            $(`.${guidTranslate}moreAplacationText img`).attr("src", assetUrl);
            $(`.${guidTranslate}moreAplacationText span`).text(description);

            $(`.${guidTranslate}footer-left-side img`).attr('src', assetUrl);
            $(`#${guidTranslate}linkMoreApps`).attr('href', adsUrl).find('span').text(description);

            if (animate) {
                animateBanner();
            }
        }
    });
}

const animateBanner = () => {
    const $leftSideBlock = $(`.${guidTranslate}footer-left-side`);
    const $mediumAdBlock = $(`.${guidTranslate}add-link`);

    $leftSideBlock.removeClass('scale-up-center');
    $mediumAdBlock.removeClass('scale-up-center');

    setTimeout(() => {
        $mediumAdBlock.addClass('scale-up-center');
        $leftSideBlock.addClass('scale-up-center');
    }, 100);
};

const getText = (language_code, constant_name) => {
    if (!(language_code in localesLng)) {
        console.error(`Unable to find locale code "${language_code}"`);
        return constant_name;
    }

    if (!(constant_name in localesLng[language_code])) {
        console.error(`Unable to find constant "${constant_name}" for "${language_code}" locale`);
        return constant_name;
    }

    return localesLng[language_code][constant_name];
};

//set app language
function localize(lng = 'en') {
    let temp = browser.i18n.getMessage('titleText');
    lng = lng.trim();

    fillLanguages();
    initSmallLngList();
    initLangLists();

    translationErrorMsg = getText(lng, 'serverErrorText');
    voiceErrorMsg = getText(lng, 'voiceLoadErrorText');

    $(`.${guidTranslate}change-ext-lng label`).text(getText(lng, 'extLanguageText'));
    $('.lexical-error-msg:not(.bookmark-error-msg)').text(getText(lng, 'vocabNotFoundText'));
    $('.bookmark-error-msg').text(getText(lng, 'bookmarkNotFoundText'));
    lexicalError = getText(lng, 'vocabNotFoundText');
    bookmarkError = getText(lng, 'bookmarkNotFoundText');
    areaSelectionHint = getText(lng, 'areaSelectionHint');

    $(`.${guidTranslate}log-out`).text(getText(lng, 'logoutText'));
    $(`.${guidTranslate}speed-change-slider-header > span`).text(getText(lng, 'voiceSpeedText'));
    $(`.${guidTranslate}change-voice-gender > span`).text(getText(lng, 'voiceText'));
    $(`.${guidTranslate}settings-radio:not(.settings-second-radio) span`).text(getText(lng, 'maleText'));
    $('.settings-second-radio span').text(getText(lng, 'femaleText'));
    $(`.${guidTranslate}show-in-small-menu .${guidTranslate}left-side > span:not(.${guidTranslate}settings-gray-text)`).text(getText(lng, 'wordAutoTranslateText'));
    $(`.${guidTranslate}show-in-small-menu .${guidTranslate}left-side > span.${guidTranslate}settings-gray-text`).text(getText(lng, 'wordAutoTranslateSelectText'));
    $(`.${guidTranslate}show-translition .${guidTranslate}left-side > span:not(.${guidTranslate}settings-gray-text)`).text(getText(lng, 'sentenceTranslateAutoText'));
    $(`.${guidTranslate}show-translition .${guidTranslate}left-side > span.${guidTranslate}settings-gray-text`).text(getText(lng, 'sentenceTranslateAutoSelectText'));
    $(`.${guidTranslate}show-translation-icon .${guidTranslate}left-side > span:not(.${guidTranslate}settings-gray-text)`).text(getText(lng, 'translateIconTitle'));
    $(`.${guidTranslate}show-translation-icon .${guidTranslate}left-side > span.${guidTranslate}settings-gray-text`).text(getText(lng, 'translateIconDescription'));
    $(`.${guidTranslate}show-speak-icon .${guidTranslate}left-side > span:not(.${guidTranslate}settings-gray-text)`).text(getText(lng, 'speakIconTitle'));
    $(`.${guidTranslate}show-speak-icon .${guidTranslate}left-side > span.${guidTranslate}settings-gray-text`).text(getText(lng, 'speakIconDescription'));
    $('#ui-id-1').text(getText(lng, 'generalTabText'));
    $('#ui-id-2').text(getText(lng, 'accountTabText'));
    $('#ui-id-3').text(getText(lng, 'infoTabText'));
    $('#ui-id-4').text(getText(lng, 'aboutTabText'));
    $(`.${guidTranslate}account-headline`).text('Lingvanex ' + getText(lng, 'accountTabText'));
    $(`#${guidTranslate}sign-in-email`).text(getText(lng, 'aboutTabText'));
    $(`#${guidTranslate}settings-tab .${guidTranslate}info-headline`).text(getText(lng, 'infoDnwTabText'));
    $(`#${guidTranslate}settings-tab .${guidTranslate}info-btn-download`).text(getText(lng, 'downloadBtnText'));
    $(`#${guidTranslate}welcome-tab .${guidTranslate}info-headline`).text(getText(lng, 'welcomeMessage'));
    $(`#${guidTranslate}welcome-tab .${guidTranslate}info-btn-download`).text(getText(lng, 'startButton'));
    $(`label[for='${guidTranslate}analytics']`).text(getText(lng, 'collectAnalytics'));
    $(`.${guidTranslate}btn-rate`).text(getText(lng, 'leaveFeedbackText'));
    $(`.${guidTranslate}btn-support`).text(getText(lng, 'contactUsText'));
    $(`#${guidTranslate}aboutVersion span`).text(getText(lng, 'versionText') + ' ');
    $(`.${guidTranslate}translator-setting-headline`).text(getText(lng, 'settingText'));
    $(`.${guidTranslate}terms-link`).text(getText(lng, 'agreementText'));
    $(`.${guidTranslate}privacy-policy-link`).text(getText(lng, 'confidentialityText'));
    $(`.${guidTranslate}third-components`).text(getText(lng, 'thirdPartyComponentsText'));
    $(`.${guidTranslate}sign-in-email-container label,.${guidTranslate}reg-email-container label`).text(
        getText(lng, 'emailText')
    );
    $(`.${guidTranslate}sign-in-username-container label`).text(getText(lng, 'usernameText'));
    $(`.${guidTranslate}sign-in-psw-container label`).text(getText(lng, 'passwordText'));
    $(`.${guidTranslate}psw-recovery a`).text(getText(lng, 'frgPasswordText'));
    $(`.${guidTranslate}sign-in-submit`).text(getText(lng, 'signInText'));
    $(`.${guidTranslate}create-acc a`).html(
        `${getText(lng, 'dontHaveAccountText')} <span class="${guidTranslate}text-important">${getText(
            lng,
            'signUpText'
        )}</span>`
    );
    $(`.${guidTranslate}reg-submit`).text(getText(lng, 'signUpText'));
    //$(`#${guidTranslate}translator-title`).text(temp);
    $(`.${guidTranslate}sign-in-acc a`).html(
        `${getText(lng, 'haveAccountText')} <span class="${guidTranslate}text-important">${getText(
            lng, 'signInText'
        )}</span>`
    );
    $(`.${guidTranslate}privacy-policy`).html(`
        <span>${getText(lng, 'doYouHaveText')}<br>
        <span class="${guidTranslate}text-important ${guidTranslate}terms-link">${getText(
        lng,
        'agreementText'
    )}</span> ${getText(lng, 'andText')}
                                            <span class="${guidTranslate}text-important ${guidTranslate}privacy-policy-link">${getText(
        lng,
        'privacyPolicyText'
    )}</span></span>
    `);
    $(`#${guidTranslate}autoDetect`).text(getText(lng, 'autoDetectionText'));
    autoDetectionText = getText(lng, 'autoDetectionText');

    $(`#${guidTranslate}btn-info`).attr('title', getText(lng, 'aboutText'));
    $(`#${guidTranslate}btnCloseList`).attr('title', getText(lng, 'closeText'));
    $(`#${guidTranslate}btnCloseSupport`).attr('title', getText(lng, 'closeText'));
    $(`#${guidTranslate}btnCloseAbout`).attr('title', getText(lng, 'closeText'));
    $(`#${guidTranslate}btn-swap`).attr('title', getText(lng, 'swapText'));
    $(`.${guidTranslate}fa-volume-up`).attr('title', getText(lng, 'listenText'));
    $(`#${guidTranslate}linkMoreApps span`).text(getText(lng, 'moreAppsText'));
    $(`#${guidTranslate}btnTranslate`).text(getText(lng, 'translateText'));
    $(`#${guidTranslate}dictionary-title`).text(getText(lng, 'dictionaryText'));
    $(`#${guidTranslate}select-title`).text(getText(lng, 'languageSelectionText'));
    $(`#${guidTranslate}support-title`).text(getText(lng, 'supportText'));
    $(`#${guidTranslate}emailText`).text(getText(lng, 'emailText'));
    $(`#${guidTranslate}messageText`).text(getText(lng, 'messageText'));
    $(`#${guidTranslate}btnSupportSend`).text(getText(lng, 'sendText'));
    $('#btnPrivacy').text(getText(lng, 'confidentialityText'));
    $('#btnTerms').text(getText(lng, 'termsText'));
    $('#btnSupport').text(getText(lng, 'supportText'));
    $('#btnRate').text(getText(lng, 'rateText'));
    $(`#${guidTranslate}searchLanguage,#${guidTranslate}singleWordSearch`).attr(
        'placeholder',
        getText(lng, 'searchText')
    );
    $(`#${guidTranslate}outputText`).attr('placeholder', getText(lng, 'textareaPlaceholderText'));
    $(`#${guidTranslate}sign-in-email,#${guidTranslate}reg-email`).attr('placeholder', getText(lng, 'emailText'));
    $(`#${guidTranslate}sign-in-psw,#${guidTranslate}reg-psw`).attr('placeholder', getText(lng, 'passwordText'));
    $(`#${guidTranslate}reg-name`).attr('placeholder', getText(lng, 'usernameText'));
    $(`#${guidTranslate}inputText`).attr('placeholder', getText(lng, 'fromTextAreaText'));
}

const updateSmallModalSelectedLanguage = (storageTo, storageToName, canVoiceTo) => {
    const imageUrl = `../frame/Images/flags/${storageTo.split('_').pop().toLocaleLowerCase()}-min.png`;

    getLocalizedLanguageName(storageTo, name => {
        if (!name) {
            name = storageToName;
        }
        let dropDownArrow = `<div class="${guidTranslate}ToDropArrow"><img src="${browser.extension.getURL(
            '/frame/Images/arrow.png'
        )}" alt="dropdown arrow"></div>`;

        $(`.${guidTranslate}init`)
            .html(
                `<img class="${guidTranslate}small-select-img" src="${browser.extension.getURL(
                    imageUrl
                )}">${dropDownArrow}`
            )
            .attr('data-value', storageTo)
            .attr('data-name', name)
            .attr('data-voice', canVoiceTo);
    });
};

const updateSmallSelectedLanguages = () => {
    browser.storage.local.get(['langDst', 'langDstName', 'langDstSpeakAvailable'], function(config) {
        updateSmallModalSelectedLanguage(config.langDst, config.langDstName, config.langDstSpeakAvailable);

        toggleSpeakButtons(config.langDstSpeakAvailable);
    });
};

function setLanguageSelectElement(makeEmpty = false, elementName, langCode, langName, CanVoice) {
    const code = langCode.split('_').pop().toLowerCase();
    const url = browser.extension.getURL(`/frame/Images/flags/${code}-min.png`);

    if (elementName === 'from') {
        if (code === 'auto') {
            $(`#translateUrl`).hide();
            $(`#imageOcr`).hide();
        }
        else {
            $(`#translateUrl`).show();
            $(`#imageOcr`).show();
        }
    }

    getLocalizedLanguageName(langCode, name => {
        if (!name)
            name = langName; // Just in case using stored language name

        if (!makeEmpty) {
            $(`#${guidTranslate}${elementName}`).html(`<div class="${guidTranslate}country-flag" data-voice="${CanVoice}"  style="background-image:url('${url}');" ></div>${name}`);
        } else {
            $(`#${guidTranslate}${elementName}`).val(name);
        }
    });
}

function updateSelectedLanguages(){
    browser.storage.local.get(['langSrc', 'langSrcName', 'langDst', 'langDstName', 'langSrcSpeakAvailable', 'langDstSpeakAvailable'],
        function(config) {
            setLanguageSelectElement(false, 'from', config.langSrc, config.langSrcName, config.langSrcSpeakAvailable);
            setLanguageSelectElement(false, 'to', config.langDst, config.langDstName, config.langDstSpeakAvailable);
        });
}

function getLocalizedLanguageName(langCode, cb) {
    if (langCode === 'auto') {
        return cb(autoDetectionText);
    }
    $.getJSON(browser.extension.getURL('/frame/languages.json'), function (languages) {
        browser.storage.local.get(['appLng'], function ({appLng}) {
            if (languages[langCode]) {
                return cb(languages[langCode][appLng]);
            }
        })
    });
}

function fillLanguages(callback) {
    $.getJSON(browser.extension.getURL('/frame/languages.json'), function (languages) {
        browser.storage.local.get(['languageList', 'appLng', 'recentLangs'], function ({languageList, appLng, recentLangs}) {
            if (recentLangs === undefined)
                recentLangs = [];

            let recentList = [];
            let allList = [];

            languageList.forEach(function (item) {
                //let code = item.full_code.replace(/<[^>]*>?/g, '');
                //let localizedName = browser.i18n.getMessage(code.replace('-', '0'));
                let localizedName;
                if (languages[item.full_code]) {
                    localizedName = languages[item.full_code][appLng];
                }

                if (!localizedName) {
                    localizedName = item.englishName.replace(/<[^>]*>?/g, '');
                }
                item.localizedName = localizedName;

                if (recentLangs.find(code => code === item.full_code)){
                    recentList.push(item);
                } else {
                    allList.push(item);
                }
            });
            recentList = recentList.sort((a, b) => {
                let a_pos = recentLangs.indexOf(a.full_code);
                let b_pos = recentLangs.indexOf(b.full_code);
                if (a_pos < b_pos) return -1;
                if (a_pos > b_pos) return 1;
                return 0;
            });
            allList = allList.sort(compareLangsLocalized);
            let sorted = recentList.concat(allList);


            $(`.${guidTranslate}small-select-to`).empty();
            $(`.${guidTranslate}listSelect`).empty();

            sorted.forEach(function (item) {
                const {modes} = item;
                let canVoice = false;
                let code = item.full_code.replace(/<[^>]*>?/g, '');

                const imageUrl = `/frame/Images/flags/${code.split('_').pop().toLocaleLowerCase()}-min.png`;

                if (modes) {
                    modes.map(option => {
                        const {name, value} = option;
                        if (name === 'Speech synthesis' && value) {
                            canVoice = true;
                        }
                    });
                }

                // Original unsafe code:
                // let optionHtml = `<li data-value="${code}" data-voice="${canVoice}" data-name="${item.localizedName}">
                //                 		<div class="${guidTranslate}country-flag" style="background-image:url('${browser.extension.getURL(imageUrl)}');"></div>
                //                 		${item.localizedName}
                //              	  </li>`;

                let li = $(`<li>
                                <div class="${guidTranslate}country-flag" style="background-image:url('${browser.extension.getURL(imageUrl)}');"></div>
                            </li>`);
                li.attr({
                    "data-value": code,
                    "data-voice": canVoice,
                    "data-name": item.localizedName,
                });

                li.append(DOMPurify.sanitize(item.localizedName));

                $(`.${guidTranslate}small-select-to`).append(li);
                $(`.${guidTranslate}listSelect`).append(li.clone());
            });

            // Insert to the 1st position
            $(`#${guidTranslate}fromListSelect`).prepend(
                `<li id="${guidTranslate}autoDetect" data-value="auto">` + autoDetectionText + '</li>'
            );
            // Re-attach handlers
            $(`#${guidTranslate}fromListSelect li`).off('click').on('click', fromLangSelected);
            $(`#${guidTranslate}toListSelect li`).off('click').on('click', toLangSelected);

            if (callback) callback();
        });
    });
}

function initSmallLngList() {
    updateSmallSelectedLanguages();
}

function initLangLists(callback) {
    updateSelectedLanguages();

    if (callback) {
        callback();
    }
}

const languageSearchSmall = e => {
    const $inputText = $(e.target).val().trim().toUpperCase();

    $(`.${guidTranslate}small-select-to li`).each(function (index, element) {
        let $liValue = element.innerText.trim().toUpperCase();
        if ($liValue.indexOf($inputText) > -1) {
            element.style.display = '';
        } else {
            element.style.display = 'none';
        }
    });
};

const languageSearch = () => {
    const $inputText = $(`#${guidTranslate}searchLanguage`).val().trim().toUpperCase();

    $(`#${guidTranslate}listDiv ul:visible li`).each(function (index, element) {
        let $liValue = element.innerText.trim().toUpperCase();
        if ($liValue.indexOf($inputText) > -1) {
            element.style.display = '';
        } else {
            element.style.display = 'none';
        }
    });
};

const onTermsLinkClick = () => {
    window.open(TermsAndConditionsOpenURL || 'https://lingvanex.com/en/terms-of-service/', '_blank');
    analyticsTrackEvent('Settings', 'Click Terms and Conditions');
};

const onPrivacyLinkClick = () => {
    window.open(PrivacyOpenURL || 'https://lingvanex.com/en/privacy-policy/', '_blank');
    analyticsTrackEvent('Settings', 'Click Privacy Policy');
};

function attachHandlers() {
    $(`#${guidTranslate}singleWordSearch`).off('keydown').on('keydown', onSingleWordSearch);

    $(`#${guidTranslate}btnTranslate`).off('click').on('click', onTranslateClick);
    $(`#${guidTranslate}translator-div-container .${guidTranslate}btn-speak-target .${guidTranslate}sound_inactive`)
        .off('click')
        .click(0, playSound);
    $(`#${guidTranslate}translator-div-container .${guidTranslate}btn-speak-source .${guidTranslate}sound_inactive`)
        .off('click')
        .click(1, playSound);
    $(`.${guidTranslate}btn-support`).off('click').on('click', support);
    $(`.${guidTranslate}btn-rate`).off('click').on('click', rateApp);
    $(`.${guidTranslate}link-to-website`).off('click').on('click', openWebsite);

    // Language selectors
    $(`#${guidTranslate}from`).off('click').on('click', fromClick);
    $(`#${guidTranslate}selectLanguages .${guidTranslate}FromDropArrow`).off('click').on('click', fromClick);

    $(`#${guidTranslate}to`).off('click').on('click', toClick);
    $(`#${guidTranslate}selectLanguages .${guidTranslate}ToDropArrow`).off('click').on('click', toClick);

    $(`.${guidTranslate}psw-recovery`).off('click').on('click', () => {
        analyticsTrackEvent('Settings', 'Click Restore password');
    });
    $(`#${guidTranslate}fromListSelect li`).off('click').on('click', fromLangSelected);
    $(`#${guidTranslate}toListSelect li`).off('click').on('click', toLangSelected);
    $(`.${guidTranslate}languageRevers`).off('click').on('click', languageReverse);
    $(`#${guidTranslate}change-ext-lng-btn`).off('change').on('change', onAppLngChange);
    $(`.${guidTranslate}moreAplacationText`).off('click').on('click', onMediumBannerClick);
    $(`#${guidTranslate}linkMoreApps`).off('click').on('click', onAdsClick);
    $(`.${guidTranslate}terms-link`).off('click').on('click', onTermsLinkClick);
    $(`.${guidTranslate}privacy-policy-link`).off('click').on('click', onPrivacyLinkClick);
    $(`.${guidTranslate}third-components`)
        .off('click')
        .on('click', () => analyticsTrackEvent('Settings', 'Click Third party components'));

    $(`.${guidTranslate}social-icons-item`).off('click').on('click', attachSocialButtonsLink);
    //$("#btnCloseFrame").click(closeFrame);
    $(`#${guidTranslate}btnCloseAbout`).click(closeAbout);
    $(`#${guidTranslate}btnCloseSupport`).click(closeAbout);
    $(`#${guidTranslate}btnCloseList`).click(closeLanguagesList);
    $(`.${guidTranslate}translateEngine`).click(openTranslateBy);
    $(`#${guidTranslate}searchLanguage`).on('input', languageSearch);

    $(`.${guidTranslate}small-lng-search`).on('input', languageSearchSmall);
    $(`.${guidTranslate}vcb-search-icon`).off('click').on('click', singleWordSearch);
    $(`.${guidTranslate}create-acc`).click(hideSignIn);
    $(`.${guidTranslate}sign-in-acc`).click(hideRegTab);
    $(`#${guidTranslate}sign-in-email,#${guidTranslate}sign-in-psw`).keyup(signInKeyUp);
    $(`.${guidTranslate}signIn`).off('submit').on('submit', onLoginClick);
    $(`#${guidTranslate}reg-name,#${guidTranslate}reg-email,#${guidTranslate}reg-psw`).keyup(regKeyUp);
    $(`.${guidTranslate}regForm`).off('submit').on('submit', onRegisterClick);
    $(`.${guidTranslate}close_btn_delete_text:not(.${guidTranslate}position-bottom)`).click(clearBigPopupInputArea);
    $(`.${guidTranslate}copy-text-btn`).click(copyTextToClipBoard);
    $(`.${guidTranslate}tab-container-item`).click(onTabClick);
    $(`.${guidTranslate}class-trn-close-div`).click(closeSettingPage);
    $(`#${guidTranslate}inputText,#${guidTranslate}outputText`).bind('input propertychange', textareaFromChange);
    $(`.${guidTranslate}lingvanexWebsite`).off('click').on('click', openWebsite);
    $(`.${guidTranslate}log-out`).off('click').on('click', onLogout);
    $(`.${guidTranslate}site-icons#translateUrl`).off('click').on('click', translateUrlClick);
    $('#imageOcr').off('click').on('click', captureEntryPage);
    $(`#${guidTranslate}settings-tab .${guidTranslate}info-btn-download`).off('click').on('click', moreApps);
    $(`#${guidTranslate}welcome-tab .${guidTranslate}info-btn-download`).off('click').on('click', startButtonClick);

    $(document).on('change', `input[id="${guidTranslate}analytics"]`, analyticsCheckboxChange);

    $(`.${guidTranslate}bottom-icons #clear`).off('click').on('click', clearBookmarks);
    $(`.${guidTranslate}history-clear-icons #clear`).off('click').on('click', clearHistory);
    $(`#${guidTranslate}inputText`).bind("paste", (e) => {
        console.log('paste!');
        let pastedData = e.originalEvent.clipboardData.getData('text');
        $(`#${guidTranslate}inputText`).val(pastedData);
        translate();
        return false; // Prevent text from being pasted twice
    });
    $(`#${guidTranslate}inputText`).change(function(){
        saveInputText();
    });
    $(`.${guidTranslate}settings-radio:not(.settings-second-radio) input,.settings-second-radio input`)
        .off('change')
        .on('change', onVoiceGenderChange);
}

function onAppLngChange(e) {
    const {value} = e.target;

    browser.storage.local.set({appLng: value});
    generateLocaliseSelect();
    localize(value);
    loadStorageVars();

    analyticsTrackEvent('Settings', 'Change Language', {language: value});
}

function onMediumBannerClick(e) {
    let container = $(e.target).closest(`.${guidTranslate}moreAplacationText`);
    let link = container.find('a').attr("href");
    let text = container.find('span').text();

    analyticsTrackEvent('Medium Popup', 'Click Ads', {
        url: link,
        text: text
    });
}

function onAdsClick(e) {
    let container = $(e.target).closest(`#${guidTranslate}linkMoreApps`);
    let link = container.attr("href");
    let text = container.text();

    analyticsTrackEvent('Big Popup', 'Click Ads', {
        url: link,
        text: text
    });
}

attachSocialButtonsLink = ({target}) => {
    const socialName = $(target).data('social');
    let action, linkUrl;
    switch (socialName) {
        case 'facebook':
            action = 'Click Facebook';
            linkUrl = FacebookOpenURL;
            break;
        case 'instagram':
            action = 'Click Instagram';
            linkUrl = InstagramOpenURL;
            break;
        case 'linkedin':
            action = 'Click Linkedin';
            linkUrl = LinkedinOpenURL;
            break;
        case 'twitter':
            action = 'Click Twitter';
            linkUrl = TwitterOpenURL;
            break;
        case 'telegram':
            action = 'Click Telegram';
            linkUrl = TelegramOpenURL;
            break;
        default:
            return;
    }

    analyticsTrackEvent('Settings', action);
    window.open(linkUrl, '_blank');
};

function onVoiceGenderChange(e) {
    let gender = 'Male';

    if ($(`.${guidTranslate}settings-radio:not(.settings-second-radio) input`).is(':checked')) {
        gender = 'Male';
    } else if ($('.settings-second-radio input').is(':checked')) {
        gender = 'Female';
    }
    browser.storage.local.set({voiceGender: gender});
    analyticsTrackEvent('Settings', 'Change Voice Gender', {gender: gender});
}

function captureEntryPage() {
    // Warning! Shitcode
    if (typeof hideBigPopup !== "undefined") { // If this function is defined, the function was called from the page itself
        hideBigPopup();
        if (window.OCRTranslator._initializing) {
            window.onOCRRecapture();
        } else {
            window.OCRTranslator.init();
        }
        analyticsTrackEvent('Big Popup', 'Click Image Recognition');
    } else {
        window.close();
        browser.runtime.sendMessage({msg: 'start_bg_image_capturing'});
        analyticsTrackEvent('Main Popup', 'Click Image Recognition');
    }
}

const onSettingsBtnChange = (checked, dataName) => {
    if (dataName === 'words') {
        browser.storage.local.set({allowWordAuto: checked});
        analyticsTrackEvent('Settings', 'Auto Translate Words', {enabled: checked});
    } else if (dataName === 'sentence') {
        browser.storage.local.set({allowSentenceAuto: checked});
        analyticsTrackEvent('Settings', 'Auto Translate Sentences', {enabled: checked});
    } else if (dataName === 'icon') {
        browser.storage.local.set({showTranslateIcon: checked});
        analyticsTrackEvent('Settings', 'Show Translate Icon', {enabled: checked});
    } else if (dataName === 'speak') {
        browser.storage.local.set({showSpeakIcon: checked});
        analyticsTrackEvent('Settings', 'Show Speak Icon', {enabled: checked});
    }
};

const textareaFromChange = ({target}) => {
    const value = target.value;

    if (isEmptyString(value.trim())) {
        hideSoundAndDeleteBtn();
    } else {
        showSoundAndDeleteBtn();
    }
};

const isEmptyString = text => {
    try {
        if (text.trim() === '' || !text || text.trim() === ' ' || text.trim().length === 0) {
            return true;
        } else {
            return false;
        }
    } catch (e) {
        return false;
    }
};

function closeSettingPage() {
    $(`#${guidTranslate}regular-translator-header`).show();
    $(`#${guidTranslate}setting-translator-header`).hide();
    $(`#${guidTranslate}translator-div-container`).css({
        height: '502px',
    });

    if ($('#c12b5a4e69860bc968b47223fd-welcome-tab').is(':visible')) {
        startButtonClick();
    } else {
        showTabByName('translate');
    }
}

let copyToggle;

const copyTextToClipBoard = e => {
    let outputTextArea = $(`#${guidTranslate}outputText`);

    clearTimeout(copyToggle);

    copyToggle = setTimeout(() => {
        outputTextArea.removeClass('copyTextColor');
    }, 500);
    outputTextArea.addClass('copyTextColor');

    navigator.clipboard
        .writeText(` ${outputTextArea.val()}`)
        .then(() => {
            analyticsTrackEvent('Big Popup', 'Click Copy');
        })
        .catch(err => {
            console.error('Something went wrong', err);
        });
};

const hideSoundAndDeleteBtn = () => {
    if (isEmptyString($(`#${guidTranslate}outputText`).val())) {
        $(`.${guidTranslate}btn-speak-target`).hide();
    }

    if (isEmptyString($(`#${guidTranslate}inputText`).val())) {
        $(`.${guidTranslate}close_btn_delete_text`).hide();
        $(`.${guidTranslate}btn-speak-source`).hide();
    }
};

const showSoundAndDeleteBtn = () => {
    let $btsSpeakTarget = $(`.${guidTranslate}btn-speak-target`);
    let $btsSpeakSource = $(`.${guidTranslate}btn-speak-source`);
    let hideVoiceBtn = !$(`#${guidTranslate}to > div`).data('voice') || false;
    let hideVoiceBtnSource = !$(`#${guidTranslate}from > div`).data('voice') || false;

    if (!isEmptyString($(`#${guidTranslate}outputText`).val()) && !hideVoiceBtn) {
        $btsSpeakTarget.show();
    } else if (hideVoiceBtn) {
        $btsSpeakTarget.hide();
    }

    if (!isEmptyString($(`#${guidTranslate}inputText`).val())) {
        $(`.${guidTranslate}close_btn_delete_text`).show();
        if (!hideVoiceBtnSource) {
            $btsSpeakSource.show();
        } else if (hideVoiceBtnSource) {
            $btsSpeakSource.hide();
        }
    }
};

function clearBigPopupInputArea(e) {
    analyticsTrackEvent('Big Popup', 'Click Clear Input');

    $(`#${guidTranslate}inputText`).val('');
    $(`#${guidTranslate}outputText`).val('');

    hideSoundAndDeleteBtn();
    stopAudioPlay(`.${guidTranslate}sound_activate`);
    saveInputText();
}

//check if textarea has values
if (isEmptyString(textareaFrom.val())) {
    hideSoundAndDeleteBtn();
}

function showIncorrectEmailMessage(field) {
    field.addClass(`${guidTranslate}error-msg-border`).parent().prepend(`
            <div class="${guidTranslate}error-msg" >
                Email is not valid
            </div>
        `);
}

function onRegisterClick(e) {
    const emailField = $(`#${guidTranslate}reg-email`);
    const passwordField = $(`#${guidTranslate}reg-psw`);

    const username = $(`#${guidTranslate}reg-name`).val();
    const email = emailField.val();
    const password = passwordField.val();

    analyticsTrackEvent('Settings', 'Click Register', {'username': username});

    $(`.${guidTranslate}error-msg`).remove();

    if (!validateEmail(email)) {
        showIncorrectEmailMessage(emailField);
        analyticsTrackEvent('Register', 'Error', {error: 'Invalid email'});
        return
    }

    if (!password || !username) {
        $(`.${guidTranslate}sign-in-psw-container input`).addClass(`${guidTranslate}error-msg-border`);

        analyticsTrackEvent('Register', 'Error', {error: 'Username or password is empty'});
        return;
    }

    registerUser(email, password, username);
}

const toggleRegButton = status => {
    const sbmBtw = $(`.${guidTranslate}reg-submit`);
    if (status === 'show') {
        sbmBtw.attr('disabled', true).html(`
        <img class="${guidTranslate}button_loader" src="${loader}" />
        `);
    } else if (status === 'hide') {
        sbmBtw.attr('disabled', false).html(`
         Sign in
        `);
    }
};

function toggleSpeakButtons(currentLngVoice) {
    const containers = $(`.${guidTranslate}speaker-icon-container`);

    if (currentLngVoice === true) {
        containers.visible();
    } else {
        containers.invisible();
    }
}

const userRegFailed = hide => {
    $(`.${guidTranslate}registration-container .${guidTranslate}sign-in-inputs input`).addClass(
        `${guidTranslate}error-msg-border`
    );

    if (hide) {
        $(`.${guidTranslate}registration-container .${guidTranslate}sign-in-inputs input`).removeClass(
            `${guidTranslate}error-msg-border`
        );
    }
};

function registerUser(email, password, userName) {
    toggleRegButton('show');
    userRegFailed('hide');

    browser.runtime.sendMessage({msg: 'userReg', email: email, password: password, username: userName},
        function (credentials) {
            toggleRegButton('hide');

            if (credentials) {
                showUserAccountDetails(credentials.userName)
            } else {
                userRegFailed();
            }
        }
    );
}


function login(email, password) {
    debug_log('User login: ' + email);

    toggleSignInButton('show');
    userLoginFailed('hide');

    browser.runtime.sendMessage({msg: 'userLogin', email: email, password: password},
        function (credentials) {
            toggleSignInButton('hide');
            if (credentials) {
                showUserAccountDetails(credentials.userName)
            } else {
                userLoginFailed();
            }
        });
}

const regKeyUp = () => {
    const name = $(`#${guidTranslate}reg-name`).val();
    const email = $(`#${guidTranslate}reg-email`).val();
    const psw = $(`#${guidTranslate}reg-psw`).val();

    if (validateEmail(email) && psw && name) {
        $(`.${guidTranslate}reg-submit`).addClass(`${guidTranslate}button-active`);
    } else {
        $(`.${guidTranslate}reg-submit`).removeClass(`${guidTranslate}button-active`);
    }
};

function onLoginClick(e) {
    const emailField = $(`#${guidTranslate}sign-in-email`);
    const passwordField = $(`#${guidTranslate}sign-in-psw`);
    const email = emailField.val();
    const password = passwordField.val();

    analyticsTrackEvent('Settings', 'Click Login', {'email': email});

    $(`.${guidTranslate}error-msg`).remove();

    if (!validateEmail(email)) {
        showIncorrectEmailMessage(emailField);
        analyticsTrackEvent('Login', 'Error', {error: 'Invalid email'});
        return
    }

    if (!password) {
        $(`.${guidTranslate}sign-in-psw-container input`).addClass(`${guidTranslate}error-msg-border`);
        analyticsTrackEvent('Login', 'Error', {error: 'Password is empty'});
        return
    }

    login(email, password);
}

const signInKeyUp = () => {
    const email = $(`#${guidTranslate}sign-in-email`).val();
    const psw = $(`#${guidTranslate}sign-in-psw`).val();

    if (validateEmail(email) && psw) {
        $(`.${guidTranslate}sign-in-submit`).addClass(`${guidTranslate}button-active`);
    } else {
        $(`.${guidTranslate}sign-in-submit`).removeClass(`${guidTranslate}button-active`);
    }
};

const hideRegTab = () => {
    $(`.${guidTranslate}login-container`).removeClass(`${guidTranslate}slide-top-settings-modal`);
    $(`.${guidTranslate}registration-container`).removeClass(`${guidTranslate}slide-top-registration`);
};

const hideSignIn = () => {
    analyticsTrackEvent('Settings', 'Account - Creating account');
    $(`.${guidTranslate}login-container`).addClass(`${guidTranslate}slide-top-settings-modal`);
    $(`.${guidTranslate}registration-container`).addClass(`${guidTranslate}slide-top-registration`);
};

function validateEmail(email) {
    let re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return re.test(String(email).toLowerCase());
}

const onSingleWordSearch = e => {
    if (e.which === 32) {
        return false;
    } else if (e.which === 13) {
        singleWordSearch();
    }
};

const singleWordSearch = () => {
    let word = $(`#${guidTranslate}singleWordSearch`).val();
    analyticsTrackEvent('Big Popup', 'Search in Dictionary', {'text': word});
    getLexicalMeaning('en_GB', 'en_GB', word);
};

const userLoginFailed = hide => {
    $(`.${guidTranslate}login-container .${guidTranslate}sign-in-inputs input`).addClass(
        `${guidTranslate}error-msg-border`
    );

    if (hide) {
        $(`.${guidTranslate}login-container .${guidTranslate}sign-in-inputs input`).removeClass(
            `${guidTranslate}error-msg-border`
        );
    }
};

function showUserAccountDetails(username) {
    $(`.${guidTranslate}user-logged`).css('display', 'flex');
    $(`.${guidTranslate}login-container`).hide();
    $(`.${guidTranslate}registration-container`).hide();
    $(`.${guidTranslate}user-username span`).text(username);
}

const onLogout = () => {
    $(`.${guidTranslate}user-logged`).css('display', 'none');
    $(`.${guidTranslate}login-container`).show();
    $(`.${guidTranslate}registration-container`).show();
    $(`.${guidTranslate}user-username span`).text('');

    browser.storage.local.get(['userName'], function ({userName}) {
        analyticsTrackEvent('Big Popup', 'Click Logout', {user_name: userName});
    });

    browser.storage.local.set({userLogged: false, userName: null, token: null, email: null, id: null});
};

const checkUserLogin = () => {
    browser.storage.local.get(['userLogged', 'userName'], function (config) {
        if (config.userLogged) {
            showUserAccountDetails(config.userName);
        }
    });
};


const toggleSignInButton = status => {
    const sbmBtw = $(`.${guidTranslate}sign-in-submit`);
    if (status === 'show') {
        sbmBtw.attr('disabled', true).html(`
        <img class="${guidTranslate}button_loader" src="${loader}" />
        `);
    } else if (status === 'hide') {
        sbmBtw.attr('disabled', false).html(`
         Sign in
        `);
    }
};

function readBackensterParams(callback) {
    debug_log('readBackensterParams');

    $.ajax({
        type: 'post',
        timeout: 15000,
        url: 'https://backenster.com/api/app/config',
        cache: false,
        dataType: 'json',
        data: {
            appKey: window.LingvanexEnv.backensterKey,
            uuid: uuidv,
        },
        success: function ({config, err}) {
            if (err) {
                console.error('backenster config error: ' + response.err);
                //   trackEvent('error', `web server`, `backensterConfig, ${response.statusText}, ${response.err}`);
            } else if (config) {
                const {
                    AdChangeInterval,
                    SiteURL,
                    MoreAppsURL,
                    CharacterCountRequestLimitFree,
                    RatingTranslationEventCount,
                    TTSRequestLimit,
                    FacebookURL,
                    TwitterURL,
                    ThirdPartyURL,
                    PrivacyURL,
                    TermsAndConditionsURL,
                    InstagramURL,
                    LinkedInURL,
                    TelegramURL,
                } = config;

                lingvanexUrl = lingvanexUrl || SiteURL;
                FacebookOpenURL = FacebookOpenURL || FacebookURL;
                TwitterOpenURL = TwitterOpenURL || TwitterURL;
                InstagramOpenURL = InstagramOpenURL || InstagramURL;
                TelegramOpenURL = TelegramOpenURL || TelegramURL;
                LinkedinOpenURL = LinkedinOpenURL || LinkedInURL;
                PrivacyOpenURL = PrivacyOpenURL || PrivacyURL;
                TermsAndConditionsOpenURL = TermsAndConditionsOpenURL || TermsAndConditionsURL;
                ThirdPartyOpenURL = ThirdPartyOpenURL || ThirdPartyURL;
                backensterConfig = config;
                backensterAdChangeInterval = backensterAdChangeInterval || AdChangeInterval;
                backensterCharacterCountRequestLimitFree = backensterCharacterCountRequestLimitFree || CharacterCountRequestLimitFree;
                backensterRatingTranslationEventCount = backensterRatingTranslationEventCount || RatingTranslationEventCount;
                backensterTTSRequestLimit = backensterTTSRequestLimit || TTSRequestLimit;
                backensterMoreAppsURL = backensterMoreAppsURL || MoreAppsURL;
                $(`#${guidTranslate}linkMoreApps`).attr('href', backensterMoreAppsURL);
                $(`.${guidTranslate}terms-link`).attr('href', TermsAndConditionsOpenURL);
                $(`.${guidTranslate}privacy-policy-link`).attr('href', PrivacyOpenURL);
                $(`.${guidTranslate}third-components`).attr('href', ThirdPartyOpenURL);
            }
            hideOutputProgress();
            if (callback) callback();
        },
        error: function (err) {
            console.error('backenster config error: ' + err);
            //   trackEvent('error', `web server`, `backensterConfig, ${err.statusText}, ${err.responseText}`);
            if (callback) callback();
        },
    });
}

// #endregion
function openTranslateBy() {
    if (translatorLink) {
        let win = window.open(translatorLink, '_blank');
        if (win) {
            win.focus();
        } else {
            alert('Please allow popups');
        }
    }
}

function fromClick(e) {
    debug_log('fromClick');

    const parent = getParentPopupByTarget(e.target);
    const parentName = getPopupNameById(parent[0].id);

    let list = document.getElementById(`${guidTranslate}listDiv`);
    let list_visible = list.style.display !== 'none';
    let from_activated = document.getElementById(`${guidTranslate}fromListSelect`).style.display === 'block';

    if (list_visible)
        closeLanguagesList(e);

    if (!(list_visible && from_activated)) { // Check for hidden will not work here
        list.style.display = 'block';
        $(`.${guidTranslate}FromDropArrow`).addClass(`${guidTranslate}arrowClosed`).animate('fast');
        $(`#${guidTranslate}listDiv`).removeClass(`${guidTranslate}alignRight`);

        $(`.${guidTranslate}translator-list #${guidTranslate}to .${guidTranslate}country-flag`).removeClass(
            `${guidTranslate}showCloudArrow`
        );
        $(`.${guidTranslate}translator-list #${guidTranslate}from .${guidTranslate}country-flag`).addClass(
            `${guidTranslate}showCloudArrow`
        );

        document.getElementById(`${guidTranslate}fromListSelect`).style.display = 'block';
        document.getElementById(`${guidTranslate}toListSelect`).style.display = 'none';

        analyticsTrackEvent(parentName, 'Show Languages List: From');
    }
}

function setLanguagesListPosition(list, target) {
    let bounding = list.getBoundingClientRect();
    let top = bounding.top;

    if (bounding.bottom > (window.innerHeight || document.documentElement.clientHeight))
        top = top - (bounding.bottom - (window.innerHeight || document.documentElement.clientHeight));
}

function toClick(e) {
    debug_log('toClick');

    const parent = getParentPopupByTarget(e.target);
    const parentName = getPopupNameById(parent[0].id);

    let list = document.getElementById(`${guidTranslate}listDiv`);
    let list_visible = list.style.display !== 'none';
    let to_activated = document.getElementById(`${guidTranslate}toListSelect`).style.display === 'block';

    if (list_visible)
        closeLanguagesList(e);

    if (!(list_visible && to_activated)) { // Check for hidden will not work here
        list.style.display = 'block';
        $(`.${guidTranslate}ToDropArrow`).addClass(`${guidTranslate}arrowClosed`).animate('fast');

        $(`#${guidTranslate}listDiv`).addClass(`${guidTranslate}alignRight`);
        $(`.${guidTranslate}translator-list #${guidTranslate}from .${guidTranslate}country-flag`).removeClass(
            `${guidTranslate}showCloudArrow`
        );
        $(`.${guidTranslate}translator-list #${guidTranslate}to .${guidTranslate}country-flag`).addClass(
            `${guidTranslate}showCloudArrow`
        );

        document.getElementById(`${guidTranslate}fromListSelect`).style.display = 'none';
        document.getElementById(`${guidTranslate}toListSelect`).style.display = 'block';

        analyticsTrackEvent(parentName, 'Show Languages List: To');
    }
}

const resetSearchInputOnLangSelect = () => {
    $(`#${guidTranslate}searchLanguage`).val('');
};


function fromLangSelected(e) {
    debug_log('fromLangSelected');

    const parent = getParentPopupByTarget(e.target);
    const parentName = getPopupNameById(parent[0].id);

    closeLanguagesList(e);

    let code = $(this).data('value');
    let canVoice = $(this).data('voice') || false;

    let languageText = $(this).text();
    let searchVal = $(`.${guidTranslate}search-container input:not(.${guidTranslate}small-lng-search)`).val();

    let props = {
        lang_src: code,
        lang_src_name: languageText,
        search_query: searchVal
    };

    analyticsTrackEvent(parentName, 'Select language', props);

    setLanguageSelectElement(false, 'from', code, languageText, canVoice);

    browser.storage.local.set({
        langSrc: code,
        langSrcName: languageText,
        langSrcSpeakAvailable: canVoice,
    });

    browser.storage.local.get(['recentLangs'], function ({recentLangs}) {
        if (recentLangs === undefined)
            recentLangs = [];

        let pos = recentLangs.indexOf(code);
        if (pos !== -1){
            recentLangs.splice(pos, 1);
        }

        if (recentLangs.unshift(code) > 5) { // insert in the beginning
            recentLangs.pop();
        }

        browser.storage.local.set({recentLangs: recentLangs});
        fillLanguages();
    });

    let $speak = $(`.${guidTranslate}btn-speak-source`);
    if (canVoice) {
        $speak.show();
    } else {
        $speak.hide();
    }

    resetSearchInputOnLangSelect();

    listSearchReset('fromListSelect');

    translate();
}

function toLangSelected(e) {
    const parent = getParentPopupByTarget(e.target);
    const parentName = getPopupNameById(parent[0].id);

    closeLanguagesList(e);

    let code = $(this).data('value');
    let canVoice = $(this).data('voice') || false;
    let languageText = $(this).text();
    let searchVal = $(`.${guidTranslate}search-container input:not(.${guidTranslate}small-lng-search)`).val();

    let props = {
        lang_dst: code,
        lang_dst_name: languageText,
        search_query: searchVal
    };

    analyticsTrackEvent(parentName, 'Select language', props);


    setLanguageSelectElement(false, 'to', code, languageText, canVoice);

    let $speak = $(`.${guidTranslate}btn-speak-target`);
    if (canVoice) {
        $speak.show();
    } else {
        $speak.hide();
    }

    browser.storage.local.set({
        langDst: code,
        langDstName: languageText,
        langDstSpeakAvailable: canVoice,
    });

    resetSearchInputOnLangSelect();

    listSearchReset('toListSelect');
    translate();
}

const initStorage = () => { // FIXME: Remove this function
    return;
    const imageUrl = `/frame/Images/flags/${'en_US'.split('_').pop().toLocaleLowerCase()}-min.png`;

    $(`#${guidTranslate}to`).html(
        `<div class="${guidTranslate}country-flag" data-voice="true" style="background-image:url('${browser.extension.getURL(
            imageUrl
        )}');"></div>English (USA)`
    );
    try {
        setLanguageToLocalStorage('lingvanexTo', 'en_US', 'English (USA)', true, true);
    } catch (e) {
        console.error('localStorage error: ' + e);
    }
    const imageUrlFrom = `/frame/Images/flags/${'auto'.split('_').pop().toLocaleLowerCase()}-min.png`;

    $(`#${guidTranslate}from`).html(`
                           <div class="${guidTranslate}country-flag" data-voice="true" style="background-image:url('${browser.extension.getURL(
        imageUrlFrom
    )}');"></div>
                             ${autoDetectionText}
                    `);
    try {
        setLanguageToLocalStorage('lingvanexFrom', 'auto', 'AUTO-DETECTION', true, true);
    } catch (e) {
        console.error('localStorage error: ' + e);
    }
};

const listSearchReset = elementID => {
    $(`#${guidTranslate + elementID} li`).each(function (i, el) {
        el.style.display = '';
    });
};

function compareLangsLocalized(a, b) {
    if (a.localizedName < b.localizedName) return -1;
    if (a.localizedName > b.localizedName) return 1;
    return 0;
}

const generateId = () => {
    return '_' + Math.random().toString(36).substr(2, 9);
};

const handleTabsUpdate = () => {
    debug_log('handleTabsUpdate');

    browser.storage.local.get(['translateHistory'], function ({translateHistory}) {
        if (translateHistory === undefined) translateHistory = [];

        translateHistory = translateHistory.filter(item => {
            return item.remove !== true;
        });

        showTranslateHistory(translateHistory);
        showBookmarkList(translateHistory);
    });
    getSettingsValues();
};

const getSettingsValues = () => {
    browser.storage.local.get(['allowWordAuto', 'allowSentenceAuto', 'showTranslateIcon', 'showSpeakIcon', 'speedOfText', 'voiceGender'],
        function ({allowWordAuto,
                  allowSentenceAuto,
                  showTranslateIcon,
                  showSpeakIcon,
                  speedOfText,
                  voiceGender}) {

        if (voiceGender) {
            if (voiceGender === 'Female') {
                $('.settings-second-radio input').prop('checked', true);
            } else if (voiceGender === 'Male') {
                $(`.${guidTranslate}settings-radio:not(.settings-second-radio) input`).prop('checked', true);
            }
        }
        $(`#${guidTranslate}slider-range-min`).slider('value', speedOfText ? speedOfText : 100);

        $(`#${guidTranslate}switchBtn`).btnSwitch({
            Theme: 'iOS',
            OnCallback: status => onSettingsBtnChange(status, 'words'),
            OffCallback: status => onSettingsBtnChange(status, 'words'),
            ToggleState: allowWordAuto === true,
        });
        $(`#${guidTranslate}switchBtnSecond`).btnSwitch({
            Theme: 'iOS',
            OnCallback: status => onSettingsBtnChange(status, 'sentence'),
            OffCallback: status => onSettingsBtnChange(status, 'sentence'),
            ToggleState: allowSentenceAuto === true,
        });
        $(`#${guidTranslate}switchBtnTranslateIcon`).btnSwitch({
            Theme: 'iOS',
            OnCallback: status => onSettingsBtnChange(status, 'icon'),
            OffCallback: status => onSettingsBtnChange(status, 'icon'),
            ToggleState: showTranslateIcon === true,
        });
        $(`#${guidTranslate}switchBtnSpeakIcon`).btnSwitch({
            Theme: 'iOS',
            OnCallback: status => onSettingsBtnChange(status, 'speak'),
            OffCallback: status => onSettingsBtnChange(status, 'speak'),
            ToggleState: showSpeakIcon === true,
        });
    });
};


const showTranslateHistory = translateHistory => {
    let historyContent = '';

    $(`.${guidTranslate}history-link`).empty();

    if (translateHistory.length > 0) {
        const addedBookmarkIcon = browser.extension.getURL('frame/Images/added-bookmark-icon.svg');
        const addBookmarkIcon = browser.extension.getURL('frame/Images/add-bookmark-icon.svg');
        const arrowRight = browser.extension.getURL('frame/Images/arrow_right.svg');
        const deleteIcon = browser.extension.getURL('frame/Images/delete-icon.svg');

        getTemplate('/frame/history-item.html').then(function (template) {
            template = template[0].innerHTML;

            translateHistory.map(({from, id, originalText, to, translatedText, toName, fromName, bookmark}, i) => {
                //100 elements is maximum for history list
                if (i > 100) {
                    return false;
                }
                const flagFrom = browser.extension.getURL(
                    'frame/Images/flags/' + from.split('_').pop().toLocaleLowerCase().replace(/\s/g, '') + '-min.png'
                );
                const flagTo = browser.extension.getURL(
                    'frame/Images/flags/' + to.split('_').pop().toLocaleLowerCase().replace(/\s/g, '') + '-min.png'
                );

                let params = {
                    'guid': guidTranslate,
                    'id': id,
                    'bookmark-icon-src': bookmark ? addedBookmarkIcon : addBookmarkIcon,
                    'arrow-icon-src': arrowRight,
                    'delete-icon-src': deleteIcon,
                    'flagFrom': flagFrom,
                    'flagTo': flagTo,
                    'fromName': fromName,
                    'toName': toName,
                    'originalText': originalText,
                    'translatedText': translatedText
                };
                let html = Mustache.render(template, params);
                $(`.${guidTranslate}history-link`).append(html);
            });

            $(`.${guidTranslate}history-item-bookmark img`).click(toggleBookmarkHistoryList);
            $(`.${guidTranslate}history-item-remove img`).click(removeTranslateHistoryItem);
        });
    } else {
        historyContent = `<span class='center-msg history-empty-msg'>${historyEmptyText}</span>`;
        $(`.${guidTranslate}history-link`).html(historyContent); // Mozilla didn't like that!
    }

    //$(`.${guidTranslate}history-link`).html(historyContent); // Mozilla didn't like that!
};

const generateBookmarkItem = (
    id,
    addedBookmarkIcon,
    fromFlag,
    fromName,
    arrowRight,
    toFlag,
    toName,
    originalText,
    translatedText,
    deleteIcon
) => {
    return `

                 <li class="${guidTranslate}bookmark-item" data-id = "${id}">
                <div class="${guidTranslate}bookmark-item-bookmark">
                    <img src="${addedBookmarkIcon}" alt="add to bookmark">
                </div>
                <div class="${guidTranslate}bookmark-item-container">

                    <div class="${guidTranslate}bookmark-item-lng">
                        <div class="${guidTranslate}bookmark-item-lng-from">
                            <img src='${browser.extension.getURL(fromFlag)}'>
                            <span title="${fromName}" class="${guidTranslate}bookmark-lng-name-from">
                                ${fromName}
                            </span>
                        </div>
                        <img class="${guidTranslate}arrow-right" src="${arrowRight}" alt="arrow right">
                        <div class="${guidTranslate}bookmark-item-lng-to">
                            <img src='${browser.extension.getURL(toFlag)}'>
                            <span title="${toName}" class="${guidTranslate}bookmark-lng-name-to">
                                 ${toName}
                            </span>
                        </div>
                    </div>

                    <span title="${originalText}" class="${guidTranslate}bookmark-item-text-from">
                        ${originalText}
                    </span>

                    <span title="${translatedText}" class="${guidTranslate}bookmark-item-text-to">
                        ${translatedText}
                    </span>

                </div>
                <div class="${guidTranslate}bookmark-item-remove">
                    <img src="${deleteIcon}" alt="delete history element">
                </div>
            </li>

                `;
};
const showBookmarkList = translateHistory => {
    let bookmarks = translateHistory.filter(item => item.bookmark === true);

    let historyContent = '';

    if (bookmarks.length > 0) {
        bookmarks.reverse();

        const addedBookmarkIcon = browser.extension.getURL('frame/Images/added-bookmark-icon.svg');
        const arrowRight = browser.extension.getURL('frame/Images/arrow_right.svg');
        const deleteIcon = browser.extension.getURL('frame/Images/delete-icon.svg');

        bookmarks.map(({from, id, originalText, to, translatedText, toName, fromName, bookmark}) => {
            if (bookmark !== false && bookmark) {
                const fromFlag = `/frame/Images/flags/${from
                    .split('_')
                    .pop()
                    .toLocaleLowerCase()
                    .replace(/\s/g, '')}-min.png`;
                const toFlag = `/frame/Images/flags/${to
                    .split('_')
                    .pop()
                    .toLocaleLowerCase()
                    .replace(/\s/g, '')}-min.png `;

                historyContent += generateBookmarkItem(
                    id,
                    addedBookmarkIcon,
                    fromFlag,
                    fromName,
                    arrowRight,
                    toFlag,
                    toName,
                    originalText,
                    translatedText,
                    deleteIcon
                );
            }
            $(`.${guidTranslate}extension-tabs .${guidTranslate}bottom-icons`).show();
        });
    } else {
        historyContent = `<span class='center-msg bookmark-error-msg'>${bookmarkError}</span>`;
        $(`.${guidTranslate}extension-tabs .${guidTranslate}bottom-icons`).hide();
    }

    $(`.${guidTranslate}bookmark-link`).html(historyContent);
    $(`.${guidTranslate}bookmark-item-remove img,.${guidTranslate}bookmark-item-bookmark img`).click(
        removeBookmarkItem
    );
};

const removeTranslateHistoryItem = e => {
    const itemId = $(e.target).parent().parent().data('id').toString();
    analyticsTrackEvent('Big Popup', 'Remove History Item');

    bookmarkItem(itemId, true, false, () => {
        handleTabsUpdate();
    });
};

function clearHistory(e) {
    debug_log('clear history');

    analyticsTrackEvent('Big Popup', 'Click Clear History');

    browser.storage.local.get(['translateHistory'], function ({translateHistory}) {
        let bookmarks = translateHistory;
        for (key of bookmarks) {
            key.remove = true;
        }
        browser.storage.local.set({translateHistory: translateHistory}, () => {
            browser.runtime.sendMessage({
                    msg: 'syncBookmarks',
                }, () => {
                    handleTabsUpdate();
                }
            );
        });
    });
}

const getHistoryItemParent = target => {
    if ($(`#${guidTranslate}small-translator-div`).css('display') === 'flex') {
        return $(target).closest(`#${guidTranslate}small-translator-div`).find(`.${guidTranslate}translatedText`);
    } else if ($(`#${guidTranslate}medium-translator-div`).is(':visible')) {
        return $(target).closest(`#${guidTranslate}medium-translator-div`).find(`.${guidTranslate}translatedText`);
    } else {
        return $(target).parent().parent();
    }
};

function clearBookmarks() {
    analyticsTrackEvent('Big Popup', 'Clear Bookmarks');

    browser.storage.local.get(['translateHistory'], function ({translateHistory}) {
        let bookmarks = translateHistory.filter(item => {
            return item.bookmark === true;
        });
        bookmarks.map(item => {
            item.bookmark = false;
            item.synced = false; // background process will send proper calls to the backenster
        });

        browser.storage.local.set({translateHistory: translateHistory}, () => {
            browser.runtime.sendMessage({
                    msg: 'syncBookmarks',
                }, () => {
                    handleTabsUpdate();
                }
            );
        });
    });
}

function bookmarkItem(itemId, remove, bookmark, completed) {
    browser.storage.local.get(['translateHistory'], function ({translateHistory}) {
        if (translateHistory === undefined) translateHistory = [];

        let item = translateHistory.find(item => {
            return item.id === itemId.toString();
        });

        if (item !== undefined) {
            if (
                bookmark !== undefined // Костыль из-за различий bookmark item в списке и модальном окне
            )
                item.bookmark = bookmark;
            else item.bookmark = !item.bookmark;
            item.remove = remove;
            item.synced = false; // background process will send proper calls to the backenster
            debug_log(item);
        } else {
            console.log('Unable to find item ' + itemId);
        }

        browser.storage.local.set({translateHistory: translateHistory}, () => {
            browser.runtime.sendMessage({
                    msg: 'syncBookmarks',
                }, () => {
                    if (completed) {
                        completed(translateHistory);
                    }
                }
            );
        });
    });
}

function toggleBookmark(e) {
    debug_log('toggleBookmark');

    const parent = getParentPopupByTarget(e.target);
    const parentName = getPopupNameById(parent[0].id);
    const parentId = getHistoryItemParent(e.target); // FIXME: Refactor this
    const itemId = parentId.attr('data-id');

    if ($(`.${guidTranslate}bookmark-icon`).hasClass(`${guidTranslate}svg-red`)) {
        $(`.${guidTranslate}bookmark-icon`).removeClass(`${guidTranslate}svg-red`);

        bookmarkItem(itemId, false, false, () => {
            handleTabsUpdate();
        });
        analyticsTrackEvent(parentName, 'Remove Bookmark');
    } else {
        $(`.${guidTranslate}bookmark-icon`).addClass(`${guidTranslate}svg-red`);
        bookmarkItem(itemId, false, true, () => {
            handleTabsUpdate();
        });
        analyticsTrackEvent(parentName, 'Add Bookmark');
    }
}

const toggleBookmarkHistoryList = (e) => {
    debug_log('toggleBookmarkHistoryList');

    let parentId = getHistoryItemParent(e.target);
    const parent = getParentPopupByTarget(e.target);

    const parentName = getPopupNameById(parent[0].id);
    let itemId = parentId.attr('data-id');

    analyticsTrackEvent(parentName, 'Click Bookmark');

    bookmarkItem(itemId, false, undefined, () => {
        handleTabsUpdate();
    });
};

function removeBookmarkItem({target}) {
    // FIXME: Remove this!
    debug_log('removeBookmarkItem');

    let parentId = getHistoryItemParent(target);
    let itemId = parentId.attr('data-id');

    $(`.${guidTranslate}bookmark-icon`).removeClass(`${guidTranslate}svg-red`);

    bookmarkItem(itemId, false, false, () => {
        handleTabsUpdate();
    });
}

const addToTranslateHistory = (from, fromName, to, toName, text, translatedText, _id) => {
    let newItem = {
        id: _id,
        from: from,
        fromName: fromName.trim(),
        toName: toName.trim(),
        to: to,
        originalText: text,
        bookmark: false,
        translatedText: translatedText,
        time: Date.now(),
        remove: false,
    };
    debug_log('addToTranslateHistory ' + text + ' id: ' + _id);

    browser.storage.local.get(['translateHistory'], function ({translateHistory}) {
        if (translateHistory === undefined) translateHistory = [];

        let existingItem = translateHistory.find(item => {
            return item.from === newItem.from && item.to === newItem.to && item.originalText === newItem.originalText;
        });
        if (existingItem !== undefined) {
            existingItem.time = Date.now();
            existingItem.remove = false;

            if ($(`#${guidTranslate}small-translator-div`).css('display') === 'flex') {
                $(`#${guidTranslate}small-translator-div`)
                    .find(`.${guidTranslate}translatedText`)
                    .attr('data-id', existingItem.id);
            } else if ($(`#${guidTranslate}medium-translator-div`).is(':visible')) {
                $(`#${guidTranslate}medium-translator-div`)
                    .find(`.${guidTranslate}translatedText`)
                    .attr('data-id', existingItem.id);
            }
            if (existingItem.bookmark) {
                $(`.${guidTranslate}bookmark-icon`).addClass(`${guidTranslate}svg-red`);
            } else {
                $(`.${guidTranslate}bookmark-icon`).removeClass(`${guidTranslate}svg-red`);
            }
        } else {
            translateHistory.push(newItem);
            debug_log('Added to history: ' + newItem.originalText);
        }
        translateHistory.sort((a, b) => (a.time > b.time ? -1 : 1));

        browser.storage.local.set({translateHistory: translateHistory}, function () {
            handleTabsUpdate();
        });
    });
};

const showMediumLoader = () => {
    debug_log('showMediumLoader');
    $(`.${guidTranslate}spinner-gif-medium`).show();
    $(`.${guidTranslate}spinner-gif-small`).show();
    $(`.${guidTranslate}icon-nav`).hide();
    $(`.${guidTranslate}translate-small-div-bottom`).hide(); // will be enabled again after getLexicalMeaning
};

const hideMediumLoader = () => {
    debug_log('hideMediumLoader');
    $(`.${guidTranslate}spinner-gif-medium`).hide();
    $(`.${guidTranslate}spinner-gif-small`).hide();
    $(`.${guidTranslate}icon-nav`).show();
};

const selectDetectedLanguageFromServer = (fromDetected, smallModal) => {
    if (smallModal) {
        $(`.${guidTranslate}small-select-to li`).each(function () {
            let optionVal = $(this).data('value');
            if (optionVal.startsWith(fromDetected)) {
                let canVoice = $(this).data('voice') || false;

                const LangText = $(this).data('name');

                browser.storage.local.set({
                    langSrc: optionVal,
                    langSrcName: LangText,
                    langSrcSpeakAvailable: canVoice
                });

                from = optionVal;
                return false;
            }
        });
    } else {
        $(`#${guidTranslate}fromListSelect li`).each(function () {
            let optionVal = $(this).data('value');
            if (optionVal.startsWith(fromDetected)) {
                let canVoice = $(this).data('voice') || false;
                const LangText = $(this).text().trim();

                setLanguageSelectElement(false, 'from', optionVal, LangText, canVoice);

                showSoundAndDeleteBtn();

                browser.storage.local.set({
                    langSrc: optionVal,
                    langSrcName: LangText,
                    langSrcSpeakAvailable: canVoice
                });

                from = optionVal;
                return false;
            }
        });
    }
};

const onSmallTranslateSuccess = (response, translateTo, storageFromName, storageToName, to, text) => {
    const translateId = generateId();

    if (response.err) {
        translateTo.text(response.err);
        hideMediumLoader();
        showTranslateError(translateTo);
    } else {
        lastTextTranslation = response.result;

        translateTo.text(response.result).attr('data-id', translateId);

        if (translateCount >= backensterAdChangeInterval) {
            activeAdIndex++;
            browser.storage.local.set({lingvanexTranslateCount: 1});
            readTranslateCount();
            showAdsBanner(true);
        }

        hideMediumLoader();

        if (!response.result || response.result.length === 0 || !String(response.result).trim()) {
            translateTo.text(translationErrorMsg);
            //  trackEvent('error', `logic error`, `empty result of translation: ${text}`);
            return false;
        }

        if (response.from) {
            selectDetectedLanguageFromServer(response.from, true);
        }

        // if (to.startsWith('en')) {
        // 	let word = to.startsWith('en') ? response.result.replace(/<[^>]*>?/g, '') : text;
        // 	// getLexicalMeaning('en', to, word);
        // }
    }

    const fromName = storageFromName;
    const toName = storageToName;

    addToTranslateHistory(from, fromName, to, toName, text, response.result, translateId);
    isTranslating = false;

    incrementTranslateCount();
};

function getTranslatedTextTarget(container) {
    let target = $(`.${guidTranslate}translatedText`);
    if (container === 'medium') {
        target = $(`#${guidTranslate}medium-translator-div .${guidTranslate}translatedText`);
    } else if (container === 'small') {
        target = $(`#${guidTranslate}small-translator-div .${guidTranslate}translatedText`);
    }
    return target;
}

const oneWordTranslate = (text, textContainer) => {
    if (!text) return;

    text = text.trim();

    if (text.length === 0 || (text.length === 1 && !logographicScripts.includes(from))) {
        return;
    }

    if (text.length > backensterCharacterCountRequestLimitFree) {
        showLimitError();
        return;
    }

    // let currentTime = new Date().getTime();
    // if (currentTime - lastRequestTime < 1000 ){
    //     console.log('Too many requests per second!');
    //     return ;
    // }

    //lastRequestTime = currentTime;
    lastTextOriginal = text;

    showMediumLoader();

    let translatedTextTarget = getTranslatedTextTarget(textContainer);
    translatedTextTarget.text('');

    try {
        browser.storage.local.get(['langDst', 'langDstName', 'langSrc', 'langSrcName'], function(config) {
            debug_log("Translate from:'" + config.langSrc + "' to:'" + config.langDst + "' text:'" + text
                    + "' length: " + text.length);

            isTranslating = true;

            let props = {
                lang_src: config.langSrc,
                lang_dst: config.langDst,
                text: text
            };

            $.ajax({
                type: 'post',
                timeout: 15000,
                headers: {
                    Authorization: 'Fujiwaranosai',
                },
                url: 'https://backenster.com/v2/api/v3/translate/',
                cache: true,
                dataType: 'json',
                data: {
                    from: config.langSrc === 'auto' ? null : config.langSrc,
                    to:   config.langDst,
                    text: text,
                    platform: PLATFORM_NAME,
                    uuid: uuidv,
                },
                success: function (response) {
                    props['result'] = response.result;
                    analyticsTrackEvent('Translate', 'Success', props);

                    isTranslating = false;
                    onSmallTranslateSuccess(response, translatedTextTarget, config.langSrcName, config.langDstName, config.langDst, text);
                    checkAppRateShown(translateCount, backensterRatingTranslationEventCount);
                    getLexicalMeaning(config.langSrc, config.langDst, text);
                },
                error: function (err) {
                    props['error'] = err.responseText;
                    analyticsTrackEvent('Translate', 'Error', props);

                    isTranslating = false;
                    console.error('Unable to translate: ' + err.responseText);
                    hideOutputProgress();
                    hideMediumLoader();
                    showTranslateError(translatedTextTarget);
                },
            });
        });
    } catch (ex) {
        analyticsTrackEvent('Translate', 'Exception');

        isTranslating = false;
        hideMediumLoader();
        console.error('error during small window translate', ex);
        showTranslateError(translatedTextTarget);
    }
    return false;
};

onBigModalTranslateSuccess = (response, text, to, from) => {
    $(`#${guidTranslate}outputText`).val(response.result);
    showSoundAndDeleteBtn();
    if (from === 'auto' && response.from) {
        selectDetectedLanguageFromServer(response.from);
    }

    if (response.result && isOneWord(text) && (from.startsWith('en') || to.startsWith('en'))) {
        let word = to.startsWith('en') ? response.result.replace(/<[^>]*>?/g, '') : text;
        getLexicalMeaning('en_GB', to, word);
    }
};

function validURL(str) {
    var pattern = new RegExp('^(https?:\\/\\/)?' + // protocol
        '((([a-z\\d]([a-z\\d-]*[a-z\\d])*)\\.)+[a-z]{2,}|' + // domain name
        '((\\d{1,3}\\.){3}\\d{1,3}))' + // OR ip (v4) address
        '(\\:\\d+)?(\\/[-a-z\\d%_.~+]*)*' + // port and path
        '(\\?[;&a-z\\d%_.~+=-]*)?' + // query string
        '(\\#[-a-z\\d_]*)?$', 'i'); // fragment locator
    return !!pattern.test(str);
}

function onTranslateClick() {
    analyticsTrackEvent('Big Popup', 'Click Translate');
    translate();
}

function translate() {
    const outputText = $(`#${guidTranslate}outputText`);
    const inputText = $(`#${guidTranslate}inputText`);

    let text = inputText.val();

    if (!text) return;

    if (validURL(text)) {
        translateWebsite(text, false);
        return;
    }

    if (text.length > backensterCharacterCountRequestLimitFree) {
        showLimitError();
        return;
    }

    // let currentTime = new Date().getTime();
    // if (currentTime - lastRequestTime < 1000 ){
    //     console.log('Too many requests per second!');
    //     return ;
    // }

    //lastRequestTime = currentTime;
    lastTextOriginal = text;

    outputText.val('');
    try {
        browser.storage.local.get(['langSrc', 'langSrcName', 'langDst', 'langDstName'], function(config) {
            debug_log("Translate from:'" + config.langSrc + "' to:'" + config.langDst + "' text:'" + text
                    + "' length: " + text.length);

            if (text.length === 0 || (text.length === 1 && !logographicScripts.includes(config.langSrc))) {
                return;
            }

            if (config.langSrc === config.langDst) {
                outputText.val(inputText.val());
                return;
            }

            isTranslating = true;
            showOutputProgress();

            let props = {
                lang_src: config.langSrc,
                lang_dst: config.langDst,
                text: text
            };

            $.ajax({
                type: 'post',
                timeout: 15000,
                headers: {
                    Authorization: 'Fujiwaranosai',
                },
                url: 'https://backenster.com/v2/api/v3/translate/',
                dataType: 'json',
                data: {
                    from: config.langSrc === 'auto' ? null : config.langSrc,
                    to: config.langDst,
                    text: text,
                    platform: PLATFORM_NAME,
                    uuid: uuidv,
                },
                cache: true,
                success: function (response) {
                    isTranslating = false;

                    if (response.err) {
                        hideSmallPopup();
                        hideMediumPopup();
                        updateExtensionData();
                        showTranslateError(outputText);

                        props['error'] = response.err;
                        analyticsTrackEvent('Translate', 'Error', props);
                        console.error('Unable to translate: ' + response.err);
                    } else {
                        props['result'] = response.result;

                        analyticsTrackEvent('Translate', 'Success', props);

                        onBigModalTranslateSuccess(response, text, config.langDst, config.langSrc);

                        if (translateCount >= backensterAdChangeInterval) {
                            activeAdIndex++;
                            browser.storage.local.set({lingvanexTranslateCount: 1});
                            readTranslateCount();
                            showAdsBanner(true);
                        }

                        const translateId = generateId();

                        addToTranslateHistory(config.langSrc, config.langSrcName, config.langDst, config.langDstName,
                            text, response.result, translateId);

                        hideOutputProgress();
                        incrementTranslateCount();

                        checkAppRateShown(translateCount, backensterRatingTranslationEventCount);
                    }
                },
                error: function (err) {
                    props['error'] = err.responseText;
                    analyticsTrackEvent('Translate', 'Error', props);

                    isTranslating = false;
                    console.error('Unable to translate: ' + err.responseText);
                    hideOutputProgress();
                    hideSmallPopup();
                    hideMediumPopup();
                    updateExtensionData();
                    showTranslateError(outputText);
                },
            });
        });
    } catch (ex) {
        analyticsTrackEvent('Translate', 'Exception');

        isTranslating = false;
        showTranslateError(outputText);
    }
    return false;
}

function translateText(text, langSrc, langDst, callback) { // FIXME: Refactor translate() using this function
    if (langSrc === langDst) {
        return text;
    }

    $.ajax({
        type: 'post',
        timeout: 5000,
        headers: {
            Authorization: 'Fujiwaranosai',
        },
        url: 'https://backenster.com/v2/api/v3/translate/',
        cache: false,
        dataType: 'json',
        data: {
            from: langSrc === 'auto' ? null : langSrc,
            to: langDst,
            text: text,
            platform: PLATFORM_NAME,
            uuid: uuidv,
        },
        success: function (response) {
            if (response.err)
                callback(response.err);
            else
                callback(null, response)
        },
        error: function (err) {
            callback(err);
        },
    });
}

function translateUrlClick(e) {
    analyticsTrackEvent('Big Popup', 'Click Translate Url');

    if (browser.tabs) {
        browser.tabs.query({active: true, currentWindow: true}, function (tabs) {
            var activeTab = tabs[0];
            translateWebsite(activeTab.url, true)
        });
    } else {
        translateWebsite(window.location.href, true)
    }
}

function translateWebsite(url, openTranslatedUrl) {
    const outputText = $(`#${guidTranslate}outputText`);
    const inputText = $(`#${guidTranslate}inputText`);

    inputText.val(url);
    outputText.val('');

    try {
        browser.storage.local.get(['langSrc', 'langSrcName', 'langDst', 'langDstName'], function(config) {
            if (config.langSrc === config.langDst) {
                outputText.val(inputText.val());
                return;
            }

            isTranslating = true;
            showOutputProgress();

            let props = {
                lang_src: config.langSrc,
                lang_dst: config.langDst,
                url: url
            };

            $.ajax({
                type: 'post',
                timeout: 15000,
                headers: {
                    Authorization: 'Fujiwaranosai',
                },
                url: 'https://backenster.com/translateWebpageAPI',
                cache: false,
                dataType: 'json',
                data: {
                    from: config.langSrc === 'auto' ? null : config.langSrc, // FIXME: translateWebpageAPI doesn't support auto language
                    to: config.langDst,
                    url: url,
                    platform: PLATFORM_NAME,
                    uuid: uuidv,
                },
                success: function (response) {
                    isTranslating = false;

                    if (response.err) {
                        console.error('Unable to translate: ' + response.err);
                        updateExtensionData();
                        showTranslateError(outputText);

                        props['error'] = response.err;
                        analyticsTrackEvent('Translate Website', 'Error', props);
                    } else {
                        props['result'] = response.result;

                        analyticsTrackEvent('Translate Website', 'Success', props);

                        outputText.val(response.result);

                        if (openTranslatedUrl) {
                            browser.tabs.create({ url: response.result });
                        }

                        if (translateCount >= backensterAdChangeInterval) {
                            activeAdIndex++;
                            browser.storage.local.set({lingvanexTranslateCount: 1});
                            readTranslateCount();
                            showAdsBanner(true);
                        }

                        hideOutputProgress();
                        incrementTranslateCount();

                        checkAppRateShown(translateCount, backensterRatingTranslationEventCount);
                    }
                },
                error: function (err) {
                    let message = err.responseText || err.statusText;

                    props['error'] = message;
                    analyticsTrackEvent('Translate Website', 'Error', props);

                    isTranslating = false;
                    console.error('Unable to translate: ' + message);
                    hideOutputProgress();
                    showTranslateError(outputText);
                },
            });
        });
    } catch (ex) {
        analyticsTrackEvent('Translate Website', 'Exception');

        isTranslating = false;
        showTranslateError(outputText);
    }
    return false;
}


function showTranslateError(element) {
    element.text(translationErrorMsg);
}

const showMsg = msgText => {
    swal(msgText, {
        buttons: {
            cancel: 'Ok',
        },
    });
};

function showLimitError() {
    analyticsTrackEvent('Translate', 'LimitExceed');
    swal('Exceeded the limit on the number of characters per translation.', {
        dangerMode: true,
        buttons: {
            cancel: 'Close',
        },
    }).then(value => {
        switch (value) {
            case 'OK':
                support();
                break;
            default:
                break;
        }
    });
}

function checkAppRateShown(translateCount, backensterRatingTranslationEventCount) {
    browser.storage.local.get('lingvanexRateAppShown', function (config) {
        if (browser.runtime.error || !config.lingvanexRateAppShown) {
            if (translateCount % backensterRatingTranslationEventCount == 0) {
                swal('Please rate our application', {
                    buttons: {
                        cancel: 'Cancel',
                        ok: {
                            text: 'OK',
                            value: 'OK',
                        },
                    },
                }).then(value => {
                    switch (value) {
                        case 'OK':
                            rateApp();
                            break;
                        default:
                            break;
                    }
                });
                browser.storage.local.set({lingvanexRateAppShown: true});
            }
        }
    });
}

function playSound(input) {
    const parent = getParentPopupByTarget(input.target);
    const parentName = getPopupNameById(parent[0].id);

    analyticsTrackEvent(parentName, 'Click Speak');

    try {
        browser.storage.local.get(['langSrc', 'langDst'], function(config) {
            let btnId = input.data ? `.${guidTranslate}btn-speak-source` : `.${guidTranslate}btn-speak-target`;
            let lang = input.data ? config.langSrc : config.langDst;
            let text = input.data ? $(`#${guidTranslate}inputText`).val() : $(`#${guidTranslate}outputText`).val();

            if ((lang === 'auto') || (text.trim().length === 0))
                return;

            speakText(text, lang, btnId);
        });
    } catch (ex) {
        console.error('error during voice play', ex);
    }
}

const stopAudioPlay = btnId => {
    debug_log('stopAudioPlay');

    toggleSpeakAudioButton(btnId, 'normal');
    //$(btnId).removeClass(`${guidTranslate}active`).find(`.${guidTranslate}sound_activate`).hide().parent().find(`.${guidTranslate}sound_inactive`).show();
    if (audio) {
        try {
            audio.stop();
        } catch (e) {
            console.error('error during stop audio play command');
        }
    }
    audio = null;
};

const toggleSpeakAudioButton = (btnId, state) => {
    const $stop_btn = $(btnId).find(`.${guidTranslate}sound_activate`);
    const $play_btn = $(btnId).find(`.${guidTranslate}sound_inactive`);
    const $loading_indicator = $(btnId).find(`.${guidTranslate}sound_loader`);

    $stop_btn.on('click', () => stopAudioPlay(btnId));

    if (state === 'normal') {
        $(btnId).removeClass(`${guidTranslate}active`);
        $loading_indicator.hide();
        $stop_btn.hide();
        $play_btn.show();
    } else if (state === 'load') {
        $loading_indicator.show();
        $play_btn.hide();
        $stop_btn.hide();
    } else if (state === 'play') {
        $(btnId).addClass(`${guidTranslate}active`);
        //$stop_btn.off('click');
        $stop_btn.show();
        $loading_indicator.hide();
    }
};

function acPlay(arrayBuf, btnId) {
    try {
        window.AudioContext = window.AudioContext || window.webkitAudioContext;
        let context = new AudioContext();
        context.decodeAudioData(arrayBuf, audioBuf=> {
            console.log(audioBuf);
            let source = context.createBufferSource();
            source.buffer = audioBuf;
            source.connect(context.destination);
            source.start();
            toggleSpeakAudioButton(btnId, 'play');
            audio = source;
            source.addEventListener('ended', function(event) {
                stopAudioPlay(btnId);
            });
        }, err=>{
            console.log(err);
            showMsg(voiceErrorMsg);
            toggleSpeakAudioButton(btnId, 'normal');
            audio = null;
        });
    } catch(e) {
        console.log(e);
    }
}

const speakAudioOnLoad = (btnId, arrayBuf) => {
    debug_log('speakAudioOnLoad');
    
    try {
        window.AudioContext = window.AudioContext || window.webkitAudioContext;
        let context = new AudioContext();
        context.decodeAudioData(arrayBuf, audioBuf=> {
            console.log(audioBuf);
            let source = context.createBufferSource();
            source.buffer = audioBuf;
            source.connect(context.destination);
            source.start();
            toggleSpeakAudioButton(btnId, 'play');
            audio = source;
            source.addEventListener('ended', function(event) {
                stopAudioPlay(btnId);
            });
        }, err=>{
            console.log(err);
            showMsg(voiceErrorMsg);
            toggleSpeakAudioButton(btnId, 'normal');
            audio = null;
        });
    } catch(e) {
        console.log(e);
    }
};

function speakText(text, lang, btnId) {
    debug_log(`speakText: "${text}"`);

    //stop all other audios
    stopAudioPlay($(`.${guidTranslate}sound_activate`).parent());

    if (text == null || text.length < 2) return;

    if (text.length > backensterCharacterCountRequestLimitFree){
        console.warn(`The length of the text is more than ${backensterCharacterCountRequestLimitFree} symbols. The text will be truncated.`)
        text = text.substring(0, backensterCharacterCountRequestLimitFree);
    }

    browser.storage.local.get(['speedOfText', 'voiceGender'], function ({speedOfText, voiceGender}) {
        //show loader
        toggleSpeakAudioButton(btnId, 'load');

        if (backensterTTSRequestLimit && text.length > backensterTTSRequestLimit) {
            text = text.substring(0, backensterTTSRequestLimit);
        }

        voiceGender = voiceGender ? voiceGender : 'Male';
        speedOfText = speedOfText ? speedOfText : 100;

        debug_log(`textToSpeech (gender=${voiceGender}, speed=${speedOfText}, lang=${lang}): "${text}"`);

        let json = JSON.stringify({
            platform: PLATFORM_NAME,
            lang: lang,
            text: text,
            uuid: uuidv,
            gender: voiceGender,
            rate: speedOfText + '%',
        });

        //request params
        let url = `https://backenster.com/v2/api/v3/textToSpeech`;

        let xhr = new XMLHttpRequest();
        xhr.open('POST', url, true);
        xhr.responseType = 'arraybuffer';
        xhr.setRequestHeader('Authorization', 'Fujiwaranosai');
        xhr.setRequestHeader('Content-type', 'application/json; charset=utf-8');
        xhr.onload = function (event) {
            speakAudioOnLoad(btnId, xhr.response);
        };
        xhr.onerror = function (event) {
            showMsg(voiceErrorMsg);
            toggleSpeakAudioButton(btnId, 'normal');
        };
        xhr.send(json);
    });
}

function closeAbout(e) {
    $(`#${guidTranslate}translator-div-container`).removeClass(`${guidTranslate}about-body`);
    $(`#${guidTranslate}support-div`).hide();
}

function closeLanguagesList(e) {
    const parent = getParentPopupByTarget(e.target);
    const parentName = getPopupNameById(parent[0].id);

    $(`.${guidTranslate}ToDropArrow,.${guidTranslate}FromDropArrow`).removeClass(`${guidTranslate}arrowClosed`);
    $(`.${guidTranslate}translator-list #${guidTranslate}from .${guidTranslate}country-flag,.${guidTranslate}translator-list #${guidTranslate}to .${guidTranslate}country-flag`).removeClass(`${guidTranslate}showCloudArrow`);

    document.getElementById(`${guidTranslate}fromListSelect`).style.display = 'block';
    document.getElementById(`${guidTranslate}listDiv`).style.display = 'none';

    analyticsTrackEvent(parentName, 'Hide Languages List');
}

function animateReverseIcon() {
    const reverseIcon = $(`.${guidTranslate}languageRevers`);
    let degres = 0;

    //check if button is active
    if (reverseIcon.css('transform') === 'matrix(1, -2.44929e-16, 2.44929e-16, 1, 0, 0)') {
        degres = 0;
    } else {
        degres += 360;
    }
    reverseIcon.animate(
        {deg: degres},
        {
            duration: 300,
            step: function (now) {
                reverseIcon.css({transform: 'rotate(' + now + 'deg)'});
            },
        }
    );
}

function languageReverse() {
    analyticsTrackEvent('Big Popup', 'Click Reverse Language');

    browser.storage.local.get(['langSrc', 'langSrcName', 'langDst', 'langDstName', 'langSrcSpeakAvailable', 'langDstSpeakAvailable'], function(config) {
        animateReverseIcon();

        let outputText = $(`#${guidTranslate}outputText`).val();
        let inputText = $(`#${guidTranslate}inputText`);
        inputText.val(outputText);

        if (config.langSrc === 'auto') {
            showMsg("Unable to reverse languages because you can't translate to AUTO DETECTION");
            return;
        }

        browser.storage.local.set({
            langSrc: config.langDst,
            langSrcName: config.langDstName,
            langSrcSpeakAvailable: config.langDstSpeakAvailable,

            langDst: config.langSrc,
            langDstName: config.langSrcName,
            langDstSpeakAvailable: config.langSrcSpeakAvailable,
        });

        setLanguageSelectElement(false, 'from', config.langDst, config.langDstName, config.langDstSpeakAvailable);
        setLanguageSelectElement(false, 'to', config.langSrc, config.langSrcName, config.langSrcSpeakAvailable);

        showSoundAndDeleteBtn();
        translate();
    });
}

function isOneWord(text) {
    let retval = false;
    if (text) {
        let arr = text.split(' ');
        arr = arr.filter(function (n) {
            return n.trim();
        });
        retval = arr.length < 2;
    }
    return retval;
}

function renderDictionaryContent(response, word) {
    $(`.${guidTranslate}id-lexical-meaning`).empty();

    getTemplate('/frame/dictionary.html').then(function (template) {
        let contentTemplate = template[0].innerHTML; // TODO: Replace with something more specific
        let itemTemplate = template[2].innerHTML;

        let parts = [];
        $.each(response.result.partsOfSpeech, function (partName, partItems) {
            let definitions = [];
            $.each(partItems, function (index, item) {
                let examples = item.meaning.replace(/^\(/g, '').replace(/\)$/g, '').split('; ');
                let meaning_ = examples.shift(0);
                let synonyms = [];
                let hyponyms = [];
                let hypernyms = [];

                if (item.syn) {
                    synonyms = item.syn.split(',');
                }
                if (item.hyponym) {
                    hyponyms = item.hyponym.split(',');
                }
                if (item.hypernym) {
                    hypernyms = item.hypernym.split(',');
                }

                let params = {
                    'index': index + 1,
                    'guid': guidTranslate,
                    'meaning': meaning_,
                    'examples': examples,
                    'synonyms': synonyms,
                    'hypernyms': hypernyms,
                    'hyponyms': hyponyms,
                    'hasSynonyms': synonyms.length > 0,
                    'hasHyponyms': hyponyms.length > 0,
                    'hasHypernyms': hypernyms.length > 0,
                    'sound-active-icon-src': soundActive,
                    'sound-inactive-icon': soundInactive,
                    'loader-icon-src': loader,
                };
                let html = Mustache.render(itemTemplate, params);
                definitions.push(html);
            });
            parts.push({'name': partName.toUpperCase(), 'definitions': definitions});
        });

        let params = {
            'guid': guidTranslate,
            'word': word.toLowerCase(),
            'transcription': response.result['transcription'] || word,
            'partsOfSpeech': parts,
        };
        let html = Mustache.render(contentTemplate, params);

        $(`.${guidTranslate}id-lexical-meaning`).append(html);

        // Assign button handlers
        $(`.${guidTranslate}target`).click(sourceClick);
        $(`.${guidTranslate}source`).click(sourceClick);
        $(`.${guidTranslate}speak-icon`).click(onSpeakIconClick);
    });
}

const toggleDictionaryPanel = () => {
    browser.storage.local.get(['dictionaryEnabled'], function(config) {
        if (config.dictionaryEnabled) {
            $(`.${guidTranslate}translate-small-div-bottom`).show();
            $(`.${guidTranslate}vocabulary-icon-container svg`).addClass(`${guidTranslate}svg-red-border-none`);
        } else {
            $(`.${guidTranslate}translate-small-div-bottom`).hide();
        }
    });
};

function getLexicalMeaning(from, to, word) {
    $(`.${guidTranslate}id-lexical-meaning`).html(''); //clear lexical meaning

    if (word == null || from == null || word.length < 2 || !isOneWord(word)) {
        return;
    }

    debug_log("getLexicalMeaning: from:'" + from + "' to:'" + to + "' word:'" + word + "'");

    $.ajax({
        type: 'post',
        timeout: 15000,
        headers: {
            Authorization: 'Bearer sdf2fsd34lkkdfg',
        },
        url: 'https://backenster.com/v2/api/v3/getLexicalMeaning',
        cache: false,
        dataType: 'json',
        data: {
            from: from,
            to: to,
            word: word,
            platform: PLATFORM_NAME,
            uuid: uuidv,
        },
        success: function (response) {
            if (response.err) {
                console.error('getLexicalMeaning error: ' + response.err);
            } else if (response.result) {
                //hideLexicalProgress();
                if (
                    (response.result.examples === undefined || response.result.examples.length === 0) &&
                    (response.result.partsOfSpeech === undefined ||
                        Object.entries(response.result.partsOfSpeech).length === 0)
                ) {
                    $(`.${guidTranslate}vocabulary-icon-container`).hide();
                } else {
                    toggleDictionaryPanel();
                    $(`.${guidTranslate}vocabulary-icon-container`).show();
                }
                renderDictionaryContent(response, word);
                // $(`.${guidTranslate}id-lexical-meaning`).append(renderDictionaryContent(response, word));
            }
            getSentencesByWord(from, to, word);
        },
        error: function (err) {
            console.error('getLexicalMeaning error: ' + err.responseText);
            $(`.${guidTranslate}vocabulary-icon`).removeClass(`${guidTranslate}svg-red-border-none`);
            $(`.${guidTranslate}dictionary-row,.${guidTranslate}translate-small-div-bottom`).hide();
            $(`.${guidTranslate}id-lexical-meaning`).html(
                `<span class="center-msg lexical-error-msg" >${lexicalError}</span>`
            );
        },
    });
}

const onSpeakIconClick = event => {
    let tag = $(event.target).attr('tag');

    speakText(tag, 'en_GB', $(event.target).parent());
};

function renderSentencesContent(response, word) {
    getTemplate('/frame/sentences.html').then(function (template) {
        template = template[0].innerHTML;

        let i = 1;
        $.map(response.result, function (item) {
            let fromText = DOMPurify.sanitize(item.fromText);
            let exp = new RegExp(word + '(?=[\\s\\W])', 'gi');
            item.fromText = fromText.replace(exp, `<span class='${guidTranslate}dictionary-word ${guidTranslate}source ${guidTranslate}bold-class'>${word.toLowerCase()}</span>`);
            item.index = i++;
            return item;
        });

        let params = {
            'guid': guidTranslate,
            'sentences': response.result,
        };
        let html = Mustache.render(template, params);

        $(`.${guidTranslate}id-lexical-meaning`).append(html);
    });
}

function getSentencesByWord(from, to, word) {
    if (
        word == null ||
        word.length > 45 // 45 is the length of the longest word
    )
        return;

    debug_log("getSentencesByWord: from:'" + from + "' to:'" + to + "' word:'" + word + "'");

    $.ajax({
        type: 'get',
        timeout: 15000,
        headers: {
            Authorization: 'Bearer sdf2fsd34lkkdfg',
        },
        url: 'https://backenster.com/v2/api/v3/getSentencesByWord',
        cache: false,
        dataType: 'json',
        data: {
            from: from,
            to: to,
            word: word,
            platform: PLATFORM_NAME,
            uuid: uuidv,
        },
        success: function (response) {
            if (response.err) {
                console.error('getSentencesByWord error: ' + response.err);
                //trackEvent('error', `web server`, `getSentencesByWord, from: ${from}, to: ${to}, text: ${word.substring(0, 10)}, length: ${word.length}, ${response.statusText}, ${response.err}`);
            } else if (response.result && response.result.length > 0) {
                renderSentencesContent(response, word);
            }
        },
        error: function (err) {
            console.error('getSentencesByWord error: ' + err.responseJSON);
            // trackEvent('error', `web server`, `getSentencesByWord, from: ${from}, to: ${to}, text: ${word.substring(0, 10)}, length: ${word.length}, ${err.statusText}, ${err.responseText}`);
        },
    });
}

function sourceClick(sender) {
    $(`#${guidTranslate}singleWordSearch`).val(sender.currentTarget.innerText);
    $(`#${guidTranslate}inputText`).val(sender.currentTarget.innerText);
    $(`#${guidTranslate}ouputText`).val('');
    saveInputText();
    translate();
}

function targetClick(sender) { // FIXME: Remove this
    sourceClick(sender);
}

function showOutputProgress() {
    document.getElementById(`${guidTranslate}outputProgress`).style.visibility = 'visible';
}

function hideOutputProgress() {
    document.getElementById(`${guidTranslate}outputProgress`).style.visibility = 'hidden';
}

function moreApps() {
    let win = window.open(backensterMoreAppsURL, '_blank');

    analyticsTrackEvent('Settings', 'Click Download More Apps');
    if (win) {
        win.focus();
    } else {
        alert('Please allow popups');
    }
}

function startButtonClick() {
    $('.video-container').children()[0].contentWindow.postMessage('{"event":"command","func":"' + 'pauseVideo' + '","args":""}', '*');
    analyticsTrackEvent('Big Popup', 'Click Start');
    showTabByName('translate');
    browser.storage.local.set({justInstalled: false});
}

function analyticsCheckboxChange(e) {
    // Because we have two checkboxes with the same id (don't ask why)
    $(`input[id="${guidTranslate}analytics"]`).prop("checked", $(this).is(":checked"));

    if($(this).is(":checked")){
        console.log('Analytics enabled');
        browser.storage.local.set({analyticsEnabled: true});
    }
    else if($(this).is(":not(:checked)")){
        console.log('Analytics disabled');
        browser.storage.local.set({analyticsEnabled: false});
    }
}

function support() {
    analyticsTrackEvent('Settings', 'Click Contact Support');
    window.open('https://lingvanex.com/en/support/', '_blank');
}

const openWebsite = e => {
    e.preventDefault();
    analyticsTrackEvent('Settings', 'Click Lingvanex Website');
    window.open(`${lingvanexUrl}`, '_blank');
};

function rateApp() {
    analyticsTrackEvent('Settings', 'Click Send Feedback');
    try {
        let win = window.open(window.LingvanexEnv.rateUrl, '_blank');
        if (win) {
            win.focus();
        }
    } catch (e) {
        console.error('rate app link click error', e);
    }
}

const setTranslationText = selectedText => {
    debug_log('setTranslationText');
    if (selectedText && selectedText.trim()) {
        $(`#${guidTranslate}inputText`).val(selectedText);
        saveInputText();
        translate();
    } else {
        browser.storage.local.get(['inputText'], function ({inputText}) {
            $(`#${guidTranslate}inputText`).val(inputText);
            translate();
        })
    }
};

function saveInputText(){
    let text = $(`#${guidTranslate}inputText`).val();
    debug_log(`saveInputText text: ${text}`);

    browser.storage.local.set({'inputText': text});
}

window.addEventListener('keypress', function (e) {
    if (e.key === 'Enter') {
        translate();
    }
}, false);

// Once the DOM is ready...
window.addEventListener('DOMContentLoaded', () => {
    // ...query for the active tab...
    browser.tabs.query(
        {
            active: true,
            currentWindow: true,
        },
        tabs => {
            debug_log('getSelection Request');
            // ...and send a request for the DOM info...
            browser.tabs.sendMessage(tabs[0].id, {from: 'popup', subject: 'getSelection'},
                // ...also specifying a callback to be called
                //    from the receiving end (content script).
                setTranslationText
            );
        }
    );
});


browser.runtime.onMessage.addListener(function (request, sender, sendResponse) {
    if (request.msg === 'close_translate_popups') {
        hideBigPopup();
        hideSmallPopup();
        hideMediumPopup();
        hideSquareButtons();
        updateExtensionData();
        clearPopups();
    } else if (request.msg === 'start_load_animation') {
        ocrImageShowLoader();
    } else if (request.msg === 'start_image_ocr') {
        captureEntryPage();
    } else if (request.msg === 'image_ocr_success') {
        const {sourceData, translatedData} = request;
        ocrImageHideLoader();
        //showBigPopup(sourceData, translatedData);
        $(`#${guidTranslate}inputText`).val(sourceData);
        $(`#${guidTranslate}outputText`).val(translatedData);
        analyticsTrackEvent('Big Popup', 'Image Recognition: Success', {
            'originalText': sourceData,
            'translation': translatedData,
        });
        saveInputText();
    } else if (request.msg === 'image_ocr_error') {
        const {error} = request;
        ocrImageHideLoader();
        analyticsTrackEvent('Big Popup', 'Image Recognition: Error', {
            'error': error
        });
        $(`#${guidTranslate}inputText`).val(error);
    }
});

