$(document).ready(function () {
    if (typeof browser === 'undefined')
        browser = chrome;

    const translateIconUrl = browser.extension.getURL('img/icon20.svg');
    const closeButton = browser.extension.getURL('frame/Images/close.svg');
    const arrowButton = browser.extension.getURL('frame/Images/arrow.png');
    const soundActive = browser.extension.getURL('frame/Images/sound_active.png');
    const soundInactive = browser.extension.getURL('frame/Images/sound.png');
    const iconSoundActive = browser.extension.getURL('frame/Images/icon_sound_active.svg');
    const iconSoundInactive = browser.extension.getURL('frame/Images/icon_sound.svg');
    const loader = browser.extension.getURL('frame/Images/spin.gif');
    const guid = 'c12b5a4e69860bc968b47223fd-';

    const headerLink = `<link href="https://fonts.googleapis.com/css?family=Open+Sans&display=swap" rel="stylesheet">`;

    //add font to the page
    $('head').append(headerLink);
//${guid}speaker-icon-container
    const translateIcon = `<div id="lingvanex-container">
                                <div id="translator-icon" style="background-image: url(${translateIconUrl})"></div>
                                    <div id="speak-icon" class="${guid}position-center">
                                        <img src="${iconSoundActive}" class="${guid}sound_activate" alt="play sound">
                                        <img src="${iconSoundInactive}" class="${guid}sound_inactive" alt="play sound">
                                        <img src="${loader}" class="${guid}sound_loader" alt="loader">
                                    </div>
                           </div>`;

    const header = `
         <div class="${guid}header-container" id="${guid}regular-translator-header">
            <img src=${browser.extension.getURL(
        'frame/Images/logo_text.png'
    )} class="${guid}logo_text" alt="logo with text">
            <div class="${guid}tab-container">
                <div data-tab="translate"  class="${guid}tab-container-item">
                <svg xmlns="http://www.w3.org/2000/svg" width="30" height="30" viewBox="0 0 30 30" fill="none" id="${guid}translate-img" class="${guid}tab-container-icon ${guid}activeSvg">
                    <path d="M13.849 6.59674C14.0089 6.23406 14.3678 6 14.7641 6H15.7142C16.1145 6 16.4761 6.23862 16.6336 6.60655L23.6557 23.0146C23.938 23.6744 23.454 24.408 22.7363 24.408H22.0135C21.6063 24.408 21.2399 24.1612 21.0868 23.784L19.7472 20.482C19.5941 20.1048 19.2277 19.858 18.8205 19.858H11.409C11.0001 19.858 10.6324 20.107 10.4806 20.4866L9.16344 23.7794C9.01158 24.159 8.64387 24.408 8.23497 24.408H7.53347C6.81117 24.408 6.32711 23.6657 6.61839 23.0047L13.849 6.59674ZM18.584 17.674L15.152 9.224H15.1L11.616 17.674H18.584Z" fill="#858E99"></path>
                 </svg>

                </div>

                <div data-tab="history"  class="${guid}tab-container-item">

                  <svg xmlns="http://www.w3.org/2000/svg" width="30" height="30" id="${guid}history-img"   class="${guid}tab-container-icon"   viewBox="0 0 30 30" fill="none">
                    <mask id="path-1-inside-1" fill="white">
                    <path fill-rule="evenodd" clip-rule="evenodd" d="M7.81799 22.1428C7.43217 21.7099 7.54012 21.0491 8.00939 20.7084C8.47867 20.3677 9.13088 20.4775 9.5274 20.9006C10.6695 22.1194 12.1554 22.9762 13.7997 23.3489C15.7872 23.7994 17.8707 23.5121 19.662 22.5403C21.4534 21.5686 22.8303 19.9788 23.5364 18.0671C24.2425 16.1555 24.2295 14.0523 23.4999 12.1494C22.7703 10.2466 21.3739 8.67391 19.5707 7.72435C17.7675 6.77478 15.6807 6.51312 13.6989 6.9881C11.7171 7.46309 9.97557 8.64233 8.79877 10.3061C8.21701 11.1286 7.79288 12.0418 7.53834 12.9999H8.87221C9.40299 12.9999 9.67236 13.6384 9.30196 14.0186L6.8271 16.5588C6.59159 16.8005 6.20311 16.8005 5.96759 16.5588L3.49273 14.0186C3.12233 13.6384 3.39171 12.9999 3.92249 12.9999H5.38062C5.67321 11.606 6.24866 10.2749 7.08428 9.09347C8.55529 7.01373 10.7322 5.53967 13.2094 4.94594C15.6866 4.35221 18.2952 4.67929 20.5492 5.86624C22.8032 7.0532 24.5487 9.01908 25.4607 11.3976C26.3727 13.7762 26.3889 16.4051 25.5063 18.7947C24.6237 21.1843 22.9025 23.1716 20.6634 24.3862C18.4242 25.6009 15.8199 25.9601 13.3355 25.397C11.1939 24.9115 9.26745 23.7692 7.81799 22.1428ZM14 10.9999C14 10.4476 14.4477 9.99991 15 9.99991C15.5523 9.99991 16 10.4476 16 10.9999V15.5773L18.464 16.9999C18.9423 17.2761 19.1062 17.8876 18.8301 18.3659C18.5539 18.8442 17.9423 19.0081 17.464 18.732L14.5063 17.0243C14.1734 16.8321 13.9928 16.4774 14.0069 16.1182C14.0023 16.0794 14 16.0399 14 15.9999V10.9999Z"></path>
                    </mask>
                    <path fill-rule="evenodd" clip-rule="evenodd" d="M7.81799 22.1428C7.43217 21.7099 7.54012 21.0491 8.00939 20.7084C8.47867 20.3677 9.13088 20.4775 9.5274 20.9006C10.6695 22.1194 12.1554 22.9762 13.7997 23.3489C15.7872 23.7994 17.8707 23.5121 19.662 22.5403C21.4534 21.5686 22.8303 19.9788 23.5364 18.0671C24.2425 16.1555 24.2295 14.0523 23.4999 12.1494C22.7703 10.2466 21.3739 8.67391 19.5707 7.72435C17.7675 6.77478 15.6807 6.51312 13.6989 6.9881C11.7171 7.46309 9.97557 8.64233 8.79877 10.3061C8.21701 11.1286 7.79288 12.0418 7.53834 12.9999H8.87221C9.40299 12.9999 9.67236 13.6384 9.30196 14.0186L6.8271 16.5588C6.59159 16.8005 6.20311 16.8005 5.96759 16.5588L3.49273 14.0186C3.12233 13.6384 3.39171 12.9999 3.92249 12.9999H5.38062C5.67321 11.606 6.24866 10.2749 7.08428 9.09347C8.55529 7.01373 10.7322 5.53967 13.2094 4.94594C15.6866 4.35221 18.2952 4.67929 20.5492 5.86624C22.8032 7.0532 24.5487 9.01908 25.4607 11.3976C26.3727 13.7762 26.3889 16.4051 25.5063 18.7947C24.6237 21.1843 22.9025 23.1716 20.6634 24.3862C18.4242 25.6009 15.8199 25.9601 13.3355 25.397C11.1939 24.9115 9.26745 23.7692 7.81799 22.1428ZM14 10.9999C14 10.4476 14.4477 9.99991 15 9.99991C15.5523 9.99991 16 10.4476 16 10.9999V15.5773L18.464 16.9999C18.9423 17.2761 19.1062 17.8876 18.8301 18.3659C18.5539 18.8442 17.9423 19.0081 17.464 18.732L14.5063 17.0243C14.1734 16.8321 13.9928 16.4774 14.0069 16.1182C14.0023 16.0794 14 16.0399 14 15.9999V10.9999Z" fill="#858E99"></path>
                    <path d="M7.81799 22.1428L8.56455 21.4775H8.56455L7.81799 22.1428ZM9.5274 20.9006L8.79772 21.5844H8.79772L9.5274 20.9006ZM13.7997 23.3489L14.0208 22.3737L13.7997 23.3489ZM19.662 22.5403L20.1389 23.4193L19.662 22.5403ZM23.5364 18.0671L24.4745 18.4136V18.4136L23.5364 18.0671ZM23.4999 12.1494L24.4337 11.7914V11.7914L23.4999 12.1494ZM19.5707 7.72435L19.1048 8.60916V8.60916L19.5707 7.72435ZM13.6989 6.9881L13.4658 6.01564L13.6989 6.9881ZM8.79877 10.3061L7.98235 9.72867H7.98235L8.79877 10.3061ZM7.53834 12.9999L6.57187 12.7431L6.23798 13.9999H7.53834V12.9999ZM9.30196 14.0186L8.58571 13.3208H8.58571L9.30196 14.0186ZM6.8271 16.5588L7.54336 17.2566H7.54336L6.8271 16.5588ZM5.96759 16.5588L5.25133 17.2566H5.25134L5.96759 16.5588ZM3.49273 14.0186L2.77647 14.7164H2.77647L3.49273 14.0186ZM5.38062 12.9999V13.9999H6.19251L6.3593 13.2053L5.38062 12.9999ZM7.08428 9.09347L6.26786 8.51601V8.51602L7.08428 9.09347ZM13.2094 4.94594L13.4425 5.9184L13.2094 4.94594ZM20.5492 5.86624L21.0152 4.98143V4.98143L20.5492 5.86624ZM25.4607 11.3976L26.3945 11.0396V11.0396L25.4607 11.3976ZM25.5063 18.7947L26.4444 19.1412V19.1412L25.5063 18.7947ZM13.3355 25.397L13.5566 24.4217L13.5566 24.4217L13.3355 25.397ZM16 15.5773H15V16.1546L15.5 16.4433L16 15.5773ZM18.464 16.9999L17.964 17.8659L18.464 16.9999ZM18.8301 18.3659L17.964 17.8659V17.8659L18.8301 18.3659ZM17.464 18.732L16.964 19.598L16.964 19.598L17.464 18.732ZM14.5063 17.0243L15.0063 16.1583L15.0063 16.1583L14.5063 17.0243ZM14.0069 16.1182L15.0062 16.1574L15.0092 16.0791L15 16.0012L14.0069 16.1182ZM7.42192 19.8992C6.53003 20.5467 6.24708 21.8831 7.07144 22.8081L8.56455 21.4775C8.56628 21.4794 8.56937 21.4834 8.57263 21.4893C8.57585 21.4952 8.57846 21.5015 8.58029 21.5079C8.58398 21.5208 8.5834 21.5295 8.58298 21.5325C8.58238 21.5366 8.5827 21.5279 8.59687 21.5177L7.42192 19.8992ZM10.2571 20.2168C9.56976 19.4834 8.35983 19.2183 7.42192 19.8992L8.59687 21.5177C8.60365 21.5127 8.61897 21.5031 8.65789 21.5085C8.70174 21.5146 8.75527 21.5391 8.79772 21.5844L10.2571 20.2168ZM14.0208 22.3737C12.5722 22.0453 11.2632 21.2905 10.2571 20.2168L8.79772 21.5844C10.0758 22.9482 11.7385 23.9071 13.5787 24.3242L14.0208 22.3737ZM19.1852 21.6613C17.6072 22.5174 15.7717 22.7706 14.0208 22.3737L13.5787 24.3242C15.8028 24.8283 18.1343 24.5067 20.1389 23.4193L19.1852 21.6613ZM22.5984 17.7207C21.9763 19.4048 20.7633 20.8053 19.1852 21.6613L20.1389 23.4193C22.1434 22.3319 23.6843 20.5529 24.4745 18.4136L22.5984 17.7207ZM22.5662 12.5075C23.209 14.1838 23.2204 16.0366 22.5984 17.7207L24.4745 18.4136C25.2646 16.2743 25.2501 13.9208 24.4337 11.7914L22.5662 12.5075ZM19.1048 8.60916C20.6933 9.44568 21.9235 10.8312 22.5662 12.5075L24.4337 11.7914C23.6172 9.66208 22.0545 7.90214 20.0367 6.83954L19.1048 8.60916ZM13.932 7.96056C15.6778 7.54212 17.5163 7.77263 19.1048 8.60916L20.0367 6.83954C18.0188 5.77693 15.6835 5.48411 13.4658 6.01564L13.932 7.96056ZM9.61519 10.8836C10.6519 9.41786 12.1861 8.379 13.932 7.96056L13.4658 6.01564C11.2481 6.54718 9.29925 7.86681 7.98235 9.72867L9.61519 10.8836ZM8.50481 13.2567C8.72905 12.4126 9.10268 11.6082 9.61519 10.8836L7.98235 9.72867C7.33133 10.6491 6.8567 11.671 6.57187 12.7431L8.50481 13.2567ZM8.87221 11.9999H7.53834V13.9999H8.87221V11.9999ZM10.0182 14.7164C11.006 13.7026 10.2876 11.9999 8.87221 11.9999V13.9999C8.51835 13.9999 8.33877 13.5742 8.58571 13.3208L10.0182 14.7164ZM7.54336 17.2566L10.0182 14.7164L8.58571 13.3208L6.11084 15.861L7.54336 17.2566ZM5.25134 17.2566C5.87937 17.9013 6.91532 17.9013 7.54336 17.2566L6.11085 15.861C6.26785 15.6998 6.52684 15.6998 6.68385 15.861L5.25134 17.2566ZM2.77647 14.7164L5.25133 17.2566L6.68385 15.861L4.20899 13.3208L2.77647 14.7164ZM3.92249 11.9999C2.50707 11.9999 1.78874 13.7026 2.77647 14.7164L4.20899 13.3208C4.45592 13.5742 4.27634 13.9999 3.92249 13.9999V11.9999ZM5.38062 11.9999H3.92249V13.9999H5.38062V11.9999ZM6.26786 8.51602C5.35265 9.80996 4.72239 11.2679 4.40195 12.7945L6.3593 13.2053C6.62403 11.9441 7.14467 10.7398 7.90071 9.67093L6.26786 8.51602ZM12.9763 3.97348C10.2632 4.62376 7.87896 6.2382 6.26786 8.51601L7.90071 9.67093C9.23161 7.78925 11.2012 6.45559 13.4425 5.9184L12.9763 3.97348ZM21.0152 4.98143C18.5465 3.68143 15.6895 3.3232 12.9763 3.97348L13.4425 5.9184C15.6838 5.38121 18.044 5.67714 20.0833 6.75105L21.0152 4.98143ZM26.3945 11.0396C25.3956 8.43454 23.4838 6.28143 21.0152 4.98143L20.0833 6.75105C22.1225 7.82497 23.7019 9.60362 24.527 11.7556L26.3945 11.0396ZM26.4444 19.1412C27.4111 16.524 27.3933 13.6447 26.3945 11.0396L24.527 11.7556C25.3522 13.9076 25.3668 16.2862 24.5683 18.4483L26.4444 19.1412ZM21.1402 25.2652C23.5926 23.9349 25.4777 21.7584 26.4444 19.1412L24.5683 18.4483C23.7697 20.6103 22.2124 22.4083 20.1866 23.5072L21.1402 25.2652ZM13.1144 26.3722C15.8354 26.989 18.6878 26.5956 21.1402 25.2652L20.1866 23.5072C18.1607 24.6062 15.8043 24.9312 13.5566 24.4217L13.1144 26.3722ZM7.07144 22.8081C8.65895 24.5895 10.7689 25.8405 13.1144 26.3722L13.5566 24.4217C11.619 23.9825 9.87596 22.949 8.56455 21.4775L7.07144 22.8081ZM15 8.99991C13.8954 8.99991 13 9.89534 13 10.9999H15V8.99991ZM17 10.9999C17 9.89534 16.1046 8.99991 15 8.99991V10.9999H17ZM17 15.5773V10.9999H15V15.5773H17ZM15.5 16.4433L17.964 17.8659L18.964 16.1339L16.5 14.7113L15.5 16.4433ZM17.964 17.8659L19.6961 18.8659C20.2484 17.9094 19.9206 16.6862 18.964 16.1339L17.964 17.8659ZM17.964 17.8659L17.964 17.8659L16.964 19.598C17.9206 20.1503 19.1438 19.8225 19.6961 18.8659L17.964 17.8659ZM17.964 17.8659L15.0063 16.1583L14.0063 17.8903L16.964 19.598L17.964 17.8659ZM15.0063 16.1583L15.0062 16.1574L13.0077 16.0791C12.9796 16.7945 13.3393 17.5052 14.0063 17.8903L15.0063 16.1583ZM13 15.9999C13 16.0792 13.0047 16.1578 13.0138 16.2353L15 16.0012C15 16.0011 15 16.0007 15 15.9999H13ZM13 10.9999V15.9999H15V10.9999H13Z" fill="#858E99" mask="url(#path-1-inside-1)"></path>
                    </svg>

                </div>
                 <div data-tab="vocabulary"  class="${guid}tab-container-item">

                 <svg xmlns="http://www.w3.org/2000/svg" width="30" height="30" viewBox="0 0 30 30" fill="none" id="${guid}vocabulary-img"  class="${guid}tab-container-icon" >
                     <path d="M22.5 23.5C22.5 23.2239 22.2761 23 22 23C21.7239 23 21.5 23.2239 21.5 23.5H22.5ZM10 24.5C9.17157 24.5 8.5 23.8284 8.5 23H7.5C7.5 24.3807 8.61929 25.5 10 25.5V24.5ZM8.5 23C8.5 22.1716 9.17157 21.5 10 21.5V20.5C8.61929 20.5 7.5 21.6193 7.5 23H8.5ZM10 25.5H21.5V24.5H10V25.5ZM10 21.5H21.5V20.5H10V21.5ZM22.5 24.5V23.5H21.5V24.5H22.5ZM22.5 20.5V5.5H21.5V20.5H22.5ZM8.5 7C8.5 6.17157 9.17157 5.5 10 5.5V4.5C8.61929 4.5 7.5 5.61929 7.5 7H8.5ZM10 5.5H21.5V4.5H10V5.5ZM7.5 7V23H8.5V7H7.5ZM22.5 5.5C22.5 4.94771 22.0523 4.5 21.5 4.5V5.5H22.5ZM21.5 21.5C22.0523 21.5 22.5 21.0523 22.5 20.5H21.5V21.5ZM21.5 25.5C22.0523 25.5 22.5 25.0523 22.5 24.5H21.5V25.5Z" fill="#858E99"></path>
                     <path fill-rule="evenodd" clip-rule="evenodd" d="M8 21.5L11 21H22V5H9.82737L8 6V8V21.5ZM15.8846 8V9.73077H13V10.8846H14.7308C14.7309 12.0068 15.0869 13.0457 15.6921 13.8948C15.1099 14.4158 14.3757 14.7703 13.5643 14.8838L13.5548 14.853L13.5514 14.8419L13.5475 14.8311L12.4706 11.8311L11.5257 11.8419L9.52566 17.8419L10.4743 18.1581L10.8604 17H13.1692L13.5221 18.147L14.4779 17.853L13.9071 15.9978C14.8784 15.8267 15.7567 15.3855 16.4616 14.7546C17.3802 15.5768 18.5933 16.0767 19.9231 16.0767V14.9229C18.8889 14.9229 17.9455 14.5342 17.2311 13.8948C17.8363 13.0457 18.1923 12.0068 18.1923 10.8846H19.9231V9.73077H17.0385V8H15.8846ZM12.8615 16L12.6024 15.1581L12.0175 13.5286L11.1937 16H12.8615ZM17.0385 10.8846H16.4615H15.8847C15.8847 11.6459 16.0954 12.358 16.4616 12.9657C16.8278 12.358 17.0385 11.6459 17.0385 10.8846Z" fill="#858E99"></path>
                </svg>

                </div>

                 <div data-tab="bookmark"  class="${guid}tab-container-item">
                     <svg xmlns="http://www.w3.org/2000/svg" width="30" height="28" viewBox="0 0 30 28" fill="none" id="${guid}bookmark-img"  class="${guid}tab-container-icon"  >
                        <mask id="mask0" mask-type="alpha" maskUnits="userSpaceOnUse" x="0" y="0" width="30" height="28">
                        <rect width="30" height="28" fill="#B9C4D2"></rect>
                        </mask>
                        <g mask="url(#mask0)">
                        <path d="M14.0469 5.00105C14.3422 4.0713 15.6578 4.07131 15.9531 5.00106L17.4288 9.64786C17.5615 10.0654 17.9505 10.3481 18.3886 10.3451L23.264 10.3127C24.2395 10.3062 24.646 11.5575 23.853 12.1256L19.8897 14.9651C19.5335 15.2202 19.3849 15.6775 19.5231 16.0933L21.0605 20.7201C21.3681 21.6458 20.3038 22.4191 19.5184 21.8405L15.5932 18.9486C15.2404 18.6887 14.7596 18.6887 14.4068 18.9486L10.4816 21.8405C9.69625 22.4191 8.63188 21.6458 8.93949 20.7201L10.4769 16.0933C10.6151 15.6775 10.4665 15.2202 10.1103 14.9651L6.14698 12.1256C5.35398 11.5575 5.76053 10.3062 6.73602 10.3127L11.6114 10.3451C12.0495 10.3481 12.4385 10.0654 12.5712 9.64786L14.0469 5.00105Z" fill="#858E99" stroke="#858E99"></path>
                        </g>
                    </svg>
                </div>
                 <div data-tab="settings"  class="${guid}tab-container-item">
                     <svg xmlns="http://www.w3.org/2000/svg" width="32" height="32" viewBox="0 0 32 32" fill="none" id="${guid}settings-img"  class="${guid}tab-container-icon" >
                    <mask id="mask0" mask-type="alpha" maskUnits="userSpaceOnUse" x="0" y="0" width="32" height="32">
                    <rect width="32" height="32" fill="#B9C4D2"></rect>
                    </mask>
                    <g mask="url(#mask0)">
                    <path fill-rule="evenodd" clip-rule="evenodd" d="M12.5558 7.68553C11.9481 7.93726 11.2874 7.86721 10.763 7.55384C10.2579 7.25194 9.58976 7.04003 9.12978 7.40709C8.49892 7.91051 7.9196 8.48668 7.40601 9.12971C7.0387 9.58959 7.25086 10.2578 7.55298 10.7629C7.86666 11.2873 7.93686 11.9483 7.68503 12.5563C7.43321 13.1642 6.91618 13.582 6.32353 13.731C5.75274 13.8746 5.13023 14.197 5.06478 14.782C4.97325 15.5998 4.97549 16.4169 5.0656 17.2189C5.1313 17.8037 5.75355 18.1263 6.32422 18.27C6.91658 18.4192 7.43331 18.8369 7.68503 19.4446C7.93676 20.0523 7.86672 20.7131 7.55335 21.2374C7.25145 21.7425 7.03955 22.4106 7.40661 22.8706C7.91003 23.5015 8.48619 24.0808 9.12922 24.5944C9.5891 24.9617 10.2573 24.7495 10.7624 24.4474C11.2868 24.1337 11.9478 24.0635 12.5558 24.3154C13.1638 24.5672 13.5815 25.0842 13.7305 25.6769C13.8741 26.2477 14.1965 26.8702 14.7815 26.9356C15.5993 27.0271 16.4164 27.0249 17.2184 26.9348C17.8032 26.8691 18.1258 26.2468 18.2695 25.6762C18.4187 25.0838 18.8364 24.5671 19.4441 24.3154C20.0518 24.0636 20.7125 24.1337 21.2369 24.4471C21.742 24.749 22.4101 24.9609 22.8701 24.5938C23.501 24.0904 24.0803 23.5142 24.5939 22.8712C24.9612 22.4113 24.749 21.7431 24.4469 21.238C24.1332 20.7136 24.063 20.0526 24.3149 19.4446C24.5667 18.8366 25.0837 18.4189 25.6764 18.2698C26.2472 18.1263 26.8697 17.8038 26.9351 17.2189C27.0266 16.4011 27.0244 15.584 26.9343 14.782C26.8686 14.1972 26.2463 13.8746 25.6757 13.7309C25.0833 13.5817 24.5666 13.164 24.3149 12.5563C24.0631 11.9486 24.1332 11.2878 24.4466 10.7635C24.7485 10.2583 24.9604 9.59025 24.5933 9.13027C24.0899 8.49942 23.5137 7.9201 22.8707 7.4065C22.4108 7.03919 21.7426 7.25136 21.2375 7.55347C20.7131 7.86715 20.0521 7.93735 19.4441 7.68552C18.8361 7.4337 18.4184 6.91667 18.2694 6.32402C18.1258 5.75323 17.8034 5.13072 17.2184 5.06527C16.4006 4.97374 15.5835 4.97598 14.7815 5.06608C14.1967 5.13178 13.8741 5.75404 13.7304 6.32471C13.5812 6.91707 13.1635 7.4338 12.5558 7.68553ZM16 20C18.2091 20 20 18.2091 20 16C20 13.7909 18.2091 12 16 12C13.7909 12 12 13.7909 12 16C12 18.2091 13.7909 20 16 20Z" fill="#858E99"></path>
                    </g>
                    </svg>
                </div>
            </div>

        </div>
         <div class="${guid}header-container" id="${guid}setting-translator-header" style="display: none">
                <div class="${guid}class-trn-close-div">
                    <img src="${closeButton}" alt="close button">
                </div>
                <h2 class="${guid}translator-setting-headline">
                 Настройки
                </h2>
            </div>
    `;

    const bigTranslateModal = `
        <div class="${guid}default-translate-modal ${guid}bigTranslateModal">

            <div id="${guid}translate-tab" class="${guid}extension-tabs">
                <div id="${guid}selectLanguages">
                    <div class="${guid}translator-list">
                        <div class="${guid}form-control ${guid}lang-select" id="${guid}from">

                        </div>
                        <div class="${guid}FromDropArrow">
                            <img src="${arrowButton}" alt="dropdown arrow">
                        </div>
                    </div>
                    <div class="${guid}languageRevers">
                        <img src="${browser.extension.getURL(
        'frame/Images/reverseLanguage.png'
    )}" alt="reverse  language">
                    </div>
                    <div id="${guid}toList" class="${guid}translator-list">
                        <div class="${guid}form-control ${guid}lang-select" id="${guid}to">

                        </div>
                        <div class="${guid}ToDropArrow">
                            <img src="${arrowButton}"  alt="dropdown arrow">
                        </div>
                    </div>
                </div>
                <div id="${guid}pageWrapper">
                    <div id="${guid}header">
                        <div class="${guid}form-control ${guid}text-container">
                            <textarea id="${guid}inputText" placeholder="type here what you wanna translate" class="${guid}lang-area"></textarea>
                        </div>

                        <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 16 16" fill="none" class="c12b5a4e69860bc968b47223fd-close_btn_delete_text replaced-svg">
                        <path d="M2 2L8 8M14 14L8 8M8 8L2 14L14 2" stroke="#858E99" stroke-width="2.2" stroke-linecap="round" stroke-linejoin="round"></path>
                        </svg>

                        <div class="${guid}left-icons ${guid}position-top">
                            <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" id="imageOcr">
                            <path d="M20.5 19H3.5C3.22386 19 3 18.7761 3 18.5V8.5C3 8.22386 3.22386 8 3.5 8H6.38197C6.76074 8 7.107 7.786 7.27639 7.44721L8.22361 5.55279C8.393 5.214 8.73926 5 9.11803 5H14.882C15.2607 5 15.607 5.214 15.7764 5.55279L16.7236 7.44721C16.893 7.786 17.2393 8 17.618 8H20.5C20.7761 8 21 8.22386 21 8.5V18.5C21 18.7761 20.7761 19 20.5 19Z" stroke="#858E99" fill="#ffffff" stroke-width="2" stroke-linejoin="round"></path>
                            <circle cx="12" cy="13" r="3" stroke="#858E99" stroke-width="2" fill="#ffffff"></circle>
                            </svg>
                        </div>

                        <div id="translateUrl" class="${guid}site-icons">
                            <svg  height="24" viewBox="0 0 24 24">
                            <path d="M16.359 14.016h3.375q0.281-1.313 0.281-2.016t-0.281-2.016h-3.375q0.141 0.984 0.141 2.016t-0.141 2.016zM14.578 19.547q1.172-0.375 2.438-1.43t1.922-2.133h-2.953q-0.469 1.875-1.406 3.563zM14.344 14.016q0.141-0.984 0.141-2.016t-0.141-2.016h-4.688q-0.141 0.984-0.141 2.016t0.141 2.016h4.688zM12 19.969q1.313-1.922 1.922-3.984h-3.844q0.609 2.063 1.922 3.984zM8.016 8.016q0.563-2.016 1.406-3.563-1.172 0.375-2.461 1.43t-1.898 2.133h2.953zM5.063 15.984q0.609 1.078 1.898 2.133t2.461 1.43q-0.938-1.688-1.406-3.563h-2.953zM4.266 14.016h3.375q-0.141-0.984-0.141-2.016t0.141-2.016h-3.375q-0.281 1.313-0.281 2.016t0.281 2.016zM12 4.031q-1.313 1.922-1.922 3.984h3.844q-0.609-2.063-1.922-3.984zM18.938 8.016q-0.656-1.078-1.922-2.133t-2.438-1.43q0.844 1.547 1.406 3.563h2.953zM12 2.016q4.125 0 7.055 2.93t2.93 7.055-2.93 7.055-7.055 2.93-7.055-2.93-2.93-7.055 2.93-7.055 7.055-2.93z" fill="#858E99"></path>
                            </svg>
                        </div>

                        <div class="${guid}btn-speak-source ${guid}btn-bottom-right ${guid}speak-icon">
                            <img src="${soundActive}" class="${guid}sound_activate" alt="play sound">
                            <img src="${soundInactive}" class="${guid}sound_inactive" alt="play sound">
                            <img src="${loader}" class="${guid}sound_loader" alt="loader">
                        </div>
                        <img id="${guid}outputProgress" class="${guid}progressRing" src="${loader}"/>
                    </div>
                    <div id="${guid}content">
                        <div class="${guid}form-control ${guid}text-container">
                            <textarea id="${guid}outputText" placeholder="the translated text will be here" class="${guid}lang-area ${guid}outputText"></textarea>
                        </div>

                        <div class="${guid}left-icons ${guid}position-bottom">

                                             <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" class="c12b5a4e69860bc968b47223fd-copy-text-btn replaced-svg">
                                                <mask id="mask0" mask-type="alpha" maskUnits="userSpaceOnUse" x="0" y="0" width="24" height="24">
                                                <rect width="24" height="24" fill="#C4C4C4"></rect>
                                                </mask>
                                                <g mask="url(#mask0)">
                                                <path d="M6 16.5V6C6 4.89543 6.89543 4 8 4H15.5" stroke="#858E99" fill="#ffffff" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"></path>
                                                <path d="M18 7H10C9.44772 7 9 7.44772 9 8V20C9 20.5523 9.44772 21 10 21H14H18C18.5523 21 19 20.5523 19 20V8C19 7.44772 18.5523 7 18 7Z" stroke="#858E99" fill="#ffffff" stroke-width="2" stroke-linejoin="round"></path>
                                                </g>
                                            </svg>
                        </div>
                        <div  class="${guid}btn-speak-target ${guid}btn-bottom-right ${guid}speak-icon">
                            <img src="${soundActive}" class="${guid}sound_activate" alt="play sound">
                            <img src="${soundInactive}" class="${guid}sound_inactive" alt="play sound">
                            <img src="${loader}" class="${guid}sound_loader" alt="loader">
                        </div>
                    </div>
                </div>
                <div id="${guid}btn-row" class="${guid}popup-footer">
                    <div class="${guid}footer-left-side">
                        <img src="${browser.extension.getURL('frame/Images/more_apps.png')}">
                        <a id="${guid}linkMoreApps" target="_blank" href="#"><span>More Translator Apps</span></a>
                    </div>
                    <div class="${guid}footer-right-side">
                        <button id="${guid}btnTranslate" class="${guid}btn">Translate</button>
                    </div>
                    <!--<button id="btnMoreApps" class="btn float-right2">More Apps</button>-->
                </div>
            </div>

            <div  class="${guid}extension-tabs" id="${guid}history-tab">
                <ul class="${guid}history-link ${guid}history-link-ul">
                </ul>
                <div class="${guid}history-clear-icons">
                	<svg id="clear" data-name="clear" xmlns="http://www.w3.org/2000/svg" width="20" height="20" viewBox="0 0 753.23 753.23"><defs><style>.cls-1{fill:#858e99;}</style></defs><g id="_4" data-name="4"><path class="cls-1" d="M494.31,659.08a23.55,23.55,0,0,0,23.54-23.54V353.08a23.54,23.54,0,0,0-47.08,0V635.54A23.55,23.55,0,0,0,494.31,659.08ZM635.54,94.15H494.31V47.08A47.07,47.07,0,0,0,447.23,0H306a47.07,47.07,0,0,0-47.08,47.08V94.15H117.69a47.06,47.06,0,0,0-47.07,47.08v47.08a47.07,47.07,0,0,0,47.07,47.07v423.7a94.16,94.16,0,0,0,94.16,94.15H541.39a94.16,94.16,0,0,0,94.15-94.15V235.38a47.08,47.08,0,0,0,47.08-47.07V141.23A47.08,47.08,0,0,0,635.54,94.15ZM306,70.61a23.55,23.55,0,0,1,23.54-23.53h94.15a23.55,23.55,0,0,1,23.54,23.53V94.15H306ZM588.46,659.08a47.07,47.07,0,0,1-47.07,47.07H211.85a47.08,47.08,0,0,1-47.08-47.07V235.38H588.46ZM612,188.31H141.23a23.54,23.54,0,1,1,0-47.08H612a23.54,23.54,0,0,1,0,47.08ZM258.92,659.08a23.55,23.55,0,0,0,23.54-23.54V353.08a23.54,23.54,0,1,0-47.08,0V635.54A23.55,23.55,0,0,0,258.92,659.08Zm117.69,0a23.55,23.55,0,0,0,23.54-23.54V353.08a23.54,23.54,0,1,0-47.07,0V635.54A23.55,23.55,0,0,0,376.61,659.08Z"/></g></svg>
                </div>
            </div>

            <div  class="${guid}extension-tabs" id="${guid}vocabulary-tab">
                <div class="${guid}vcb-container">
                    <div class="${guid}vcb-input-container">
                        <img class="${guid}vcb-flag" src="${browser.extension.getURL(
        'frame/Images/flags/gb-min.png'
    )}" alt="flag">
                        <input placeholder="Search" id="${guid}singleWordSearch" type="text" />
                        <img class="${guid}vcb-search-icon" src="${browser.extension.getURL(
        'frame/Images/search-icon.svg'
    )}" alt="flag">
                    </div>

                    <div class="${guid}dictionary-row" style="padding:0;">
                        <div class="${guid}form-control ${guid}id-lexical-meaning ${guid}dictionary-div">
                        </div>
                    </div>
                </div>
            </div>

            <div  class="${guid}extension-tabs" id="${guid}bookmark-tab">
                <ul class="${guid}bookmark-link">

                </ul>
                <div class="${guid}bottom-icons">
                	<svg id="clear" data-name="clear" xmlns="http://www.w3.org/2000/svg" width="20" height="20" viewBox="0 0 753.23 753.23"><defs><style>.cls-1{fill:#858e99;}</style></defs><g id="_4" data-name="4"><path class="cls-1" d="M494.31,659.08a23.55,23.55,0,0,0,23.54-23.54V353.08a23.54,23.54,0,0,0-47.08,0V635.54A23.55,23.55,0,0,0,494.31,659.08ZM635.54,94.15H494.31V47.08A47.07,47.07,0,0,0,447.23,0H306a47.07,47.07,0,0,0-47.08,47.08V94.15H117.69a47.06,47.06,0,0,0-47.07,47.08v47.08a47.07,47.07,0,0,0,47.07,47.07v423.7a94.16,94.16,0,0,0,94.16,94.15H541.39a94.16,94.16,0,0,0,94.15-94.15V235.38a47.08,47.08,0,0,0,47.08-47.07V141.23A47.08,47.08,0,0,0,635.54,94.15ZM306,70.61a23.55,23.55,0,0,1,23.54-23.53h94.15a23.55,23.55,0,0,1,23.54,23.53V94.15H306ZM588.46,659.08a47.07,47.07,0,0,1-47.07,47.07H211.85a47.08,47.08,0,0,1-47.08-47.07V235.38H588.46ZM612,188.31H141.23a23.54,23.54,0,1,1,0-47.08H612a23.54,23.54,0,0,1,0,47.08ZM258.92,659.08a23.55,23.55,0,0,0,23.54-23.54V353.08a23.54,23.54,0,1,0-47.08,0V635.54A23.55,23.55,0,0,0,258.92,659.08Zm117.69,0a23.55,23.55,0,0,0,23.54-23.54V353.08a23.54,23.54,0,1,0-47.07,0V635.54A23.55,23.55,0,0,0,376.61,659.08Z"/></g></svg>
                </div>
            </div>

            <div  class="${guid}extension-tabs" id="${guid}settings-tab">
                <div id="${guid}tabs">
                    <ul class="${guid}tab-navigation-container">
                        <li class="${guid}navigation-item"><a href="#${guid}general">General</a></li>
                        <li class="${guid}navigation-item"><a href="#${guid}account">Account</a></li>
                        <li class="${guid}navigation-item"><a href="#${guid}info">Info</a></li>
                        <li class="${guid}navigation-item"><a href="#${guid}about">About</a></li>
                    </ul>
                    <div id="${guid}general">
                        <div class="${guid}change-ext-lng">
                            <label for="change-ext-lng-btn">Язык приложения</label>
                            <select name="change-ext-lng-btn" id="${guid}change-ext-lng-btn">
                                <option value="rus">
                                    Русский
                                </option>
                                <option value="eng">
                                    English
                                </option>
                                <option value="ch">
                                    汉字
                                </option>
                            </select>
                        </div>

                        <div class="${guid}change-voice-speed">
                            <div class="${guid}speed-change-slider-header">
                                <span>
                                    Скорость голоса
                                </span>
                                <img src="${browser.extension.getURL(
        'frame/Images/sound_active.png'
    )}" class="${guid}speak-icon" alt="sound">
                            </div>
                            <div class="${guid}speed-change-slider-body">
                                <img src="${browser.extension.getURL('frame/Images/speed_icon.svg')}" alt="speed icon" />

                                <div id="${guid}slider-range-min">
                                    <div id="${guid}custom-handle" class="${guid}ui-slider-handle"></div>
                                </div>

                                <img class="${guid}svg-reverse" src="${browser.extension.getURL(
        'frame/Images/speed_icon.svg'
    )}" alt="speed icon" />
                            </div>
                            <div class="${guid}change-voice-gender">
                                <span>
                                    Голос:
                                </span>
                                <div class="${guid}change-voice-gender-container">
                                    <div class="${guid}settings-radio">
                                        <input checked type="radio" name="gender" value="Male" id="linva-gender-radio-1"><label for="linva-gender-radio-1"> <span>Мужской</span></label>
                                    </div>

                                    <div class="${guid}settings-radio settings-second-radio">
                                        <input type="radio" name="gender" value="Female" id="linva-gender-radio-2"><label for="linva-gender-radio-2">  <span>Женский</span></label>
                                    </div>

                                </div>
                            </div>                   
                        </div>
                        <div class="${guid}show-in-small-menu">
                                <div class="${guid}left-side">
                                    <span>Автоматический перевод слова</span>
                                    <span class="${guid}settings-gray-text">
                                   Автоматический перевод при выделение слова
                                </span>
                                </div>
                                <div data-name="words" id="${guid}switchBtn"></div>
                            </div>                         
                        <div class="${guid}show-translition">
                                <div class="${guid}left-side">
                                    <span>Автоматический перевод предложения</span>
                                    <span class="${guid}settings-gray-text">
                                    Автоматический перевод при выделение предложения
                                </span>
                                </div>
                                <div data-name="sentence" id="${guid}switchBtnSecond"></div>
                            </div>
                        <div class="${guid}show-translation-icon">
                                <div class="${guid}left-side">
                                    <span>Show Translate Button</span>
                                    <span class="${guid}settings-gray-text">
                                    Show square translation icon near the selected text
                                </span>
                                </div>
                                <div data-name="icon" id="${guid}switchBtnTranslateIcon"></div>
                        </div>
                        <div class="${guid}show-speak-icon">
                                <div class="${guid}left-side">
                                    <span>Show Speak Button</span>
                                    <span class="${guid}settings-gray-text">
                                    Show square speak icon near the selected text
                                </span>
                                </div>
                                <div data-name="icon" id="${guid}switchBtnSpeakIcon"></div>
                        </div>
                    </div>
                    <div id="${guid}account">
                     <div class="${guid}user-logged">
                            <div class="${guid}user-username">
                                <img src="${browser.extension.getURL('frame/Images/crown.svg')}" alt="">
                                <span>
                                </span>
                            </div>
                            <img src="${browser.extension.getURL(
        'frame/Images/info_tab.png'
    )}" class="${guid}devices" alt="">

                            <a href="#" class="${guid}lingvanexWebsite">lingvanex.com</a>

                            <button class="${guid}log-out" type="button" >Log out</button>

                         </div>
                        <div class="${guid}login-container">
                            <h2 class="${guid}account-headline">Lingvanex Account </h2>

                            <form action="#" class="${guid}signIn">
                                <div class="${guid}sign-in-inputs">
                                    <div class="${guid}sign-in-email-container ${guid}content-reverse">

                                        <input type="email"  required id="${guid}sign-in-email" placeholder="Email">
                                        <label for="sign-in-email" >Email</label>
                                    </div>
                                    <div class="${guid}sign-in-psw-container ${guid}content-reverse">

                                        <input type="password"  required id="${guid}sign-in-psw" placeholder="Password">
                                        <label for="sign-in-psw" >Password</label>
                                    </div>

                                    <div class="${guid}psw-recovery">
                                        <a href="https://lingvanex.com/reset-password/" target="_blank">Forgot Password?</a>
                                    </div>

                                    <button class="${guid}sign-in-submit" type="submit" >Sign in</button>

                                    <div class="${guid}create-acc">
                                        <a href="#">Don’t have an account? <span class="${guid}text-important" >Create now</span></a>
                                    </div>

                                    <div class="${guid}fb-auth">

                                    </div>

                                </div>
                            </form>
                        </div>
                        <div class="${guid}registration-container">
                            <h2 class="${guid}account-headline">Creating account</h2>

                            <form action="#" class="${guid}regForm">
                                <div class="${guid}sign-in-inputs">
                                    <div class="${guid}sign-in-username-container ${guid}content-reverse">

                                        <input type="text"  required id="${guid}reg-name" placeholder="username">
                                        <label for="reg-name" >Username</label>
                                    </div>

                                    <div class="${guid}reg-email-container ${guid}content-reverse">

                                        <input type="email"  required id="${guid}reg-email" placeholder="Email">
                                        <label for="reg-email" >Email</label>
                                    </div>

                                    <div class="${guid}sign-in-psw-container ${guid}content-reverse">

                                        <input type="password"  required id="${guid}reg-psw" placeholder="Password">
                                        <label for="reg-psw" >Password</label>
                                    </div>

                                    <button class="${guid}reg-submit" type="submit" >Create now</button>

                                    <div class="${guid}sign-in-acc">
                                        <a href="#">Do you have an account? <span class="${guid}text-important" >Sign in</span></a>
                                    </div>

                                    <div class="${guid}sign-in-acc ${guid}privacy-policy">
                                        <span>By creating an account or signing in you are accepting our<br><span class="${guid}text-important ${guid}terms-link" >Terms of Service</span> and
                                            <span class="${guid}text-important ${guid}privacy-policy-link" >Privacy Policy</span></span>
                                    </div>
                                </div>

                        </div>

                    </div>

                    <div id="${guid}info">

                    <h1 class="${guid}info-headline">Download translators for all kinds of devices</h1>
                    <img class="${guid}info-image" src="${browser.extension.getURL('frame/Images/info_tab.png')}" alt="info_tab" />
                    <button class="${guid}info-btn-download" type="button">
                        Download
                    </button>

                    </div>
                    <div id="${guid}about">
                        <div class="${guid}ext-version" >
                            <img src="${browser.extension.getURL(
        'frame/Images/translate_logo.svg'
    )}" alt="logo" class="${guid}translate-icon">
                            <p id="${guid}aboutVersion">Version&nbsp;1.5.2</p>
                        </div>

                        <div class="${guid}rateAndSupport">
                            <button type="button" class="${guid}red-button ${guid}btn-rate">
                                Оставить отзыв в browser web store
                            </button>
                            <button  type="button"  class="${guid}btn-support ${guid}gray-button ${guid}btn-support">
                                Обратиться в техподдержу
                            </button>
                        </div>

                        <div class="${guid}contact">
                            <img src="${browser.extension.getURL(
        'frame/Images/logo_text.png'
    )}" alt="logo" class="${guid}text-logo">

                            <a href="https://lingvanex.com/en/"  target="_blank" class="${guid}link-to-website">www.lingvanex.com</a>

                            <div class="${guid}social-icons">
                                <img src="${browser.extension.getURL(
        'frame/Images/facebook.svg'
    )}" alt="facebook" data-social="facebook" class="${guid}social-icons-item">
                                <img src="${browser.extension.getURL(
        'frame/Images/instagramm.svg'
    )}" alt="instagram" data-social="instagram" class="${guid}social-icons-item">
                                <img src="${browser.extension.getURL(
        'frame/Images/linkedin.svg'
    )}" alt="linkedin" data-social="linkedin" class="${guid}social-icons-item">
                                <img src="${browser.extension.getURL(
        'frame/Images/twitter.svg'
    )}" alt="twitter" data-social="twitter" class="${guid}social-icons-item">
                                <img src="${browser.extension.getURL(
        'frame/Images/telegram.svg'
    )}" alt="telegram"  data-social="telegram" class="${guid}social-icons-item">
                            </div>
                        </div>

                        <div class="${guid}privacy-links">
                            <a target="_blank" href="https://lingvanex.com/en/terms-of-service/" class="${guid}terms-link" >Соглашение</a>
                            <a target="_blank" href="https://lingvanex.com/en/privacy-policy/" class="${guid}privacy-policy-link">Конфиденциальность</a>
                            <a target="_blank" href="https://lingvanex.com/" class="${guid}third-components">Сторонние компоненты</a>
                        </div>

                         <div class="analytics-option">
                              <input type="checkbox" id="${guid}analytics" name="analytics-enable" checked>
                              <label for="${guid}analytics">Allow Lingvanex to collect anonymous usage statistics</label>
                         </div>

                        <p id="${guid}aboutCopyRight">Copyright © 2020 NordicWise LLC. All Rights Reserved.</p>
                    </div>
                </div>
                <div id="${guid}support-div">
                    <p id="${guid}support-title">Support</p>
                    <div class="${guid}form-group">
                        <label id="${guid}emailText" class="${guid}lbSupport" for="supportEmail">Your e-mail:</label>
                        <input id="${guid}supportEmail" type="search" class="${guid}form-control">
                    </div>
                    <div class="${guid}form-group">
                        <label id="${guid}messageText" class="${guid}lbSupport" for="supportMessage">Message:</label>
                        <textarea id="${guid}supportMessage" class="${guid}form-control" rows="5" style="resize:none; height:95px"></textarea>
                    </div>
                    <div style="position:relative; width:100%; display: flex;justify-content: center;">
                        <p id="${guid}sendResult"></p>
                        <button id="${guid}btnSupportSend" class="${guid}btn ${guid}btn-primary">Send message</button>
                    </div>
                    <i id="${guid}btnCloseSupport" class="fa fa-btn fa-times ${guid}btn-top-right" style="color:#1675B0" aria-hidden="true" title="Close"></i>
                </div>
            </div>
            <div  class="${guid}extension-tabs" id="${guid}welcome-tab">
                <div id="${guid}info">
                    <h1 class="${guid}info-headline">Thank you for installing Lingvanex Translator!</h1>
                    <div class="video-container">
                    <iframe width="500" height="281" src="https://www.youtube-nocookie.com/embed/zfhsxfegg9c?autoplay=1&loop=1&mute=1&enablejsapi=1" frameborder="0" allow="accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>
                    </div>
                    <button class="${guid}info-btn-download" type="button">
                        Start
                    </button>
                </div>
                <div class="analytics-option">
                  <input type="checkbox" id="${guid}analytics" name="analytics-enable" checked>
                  <label for="${guid}analytics">Allow Lingvanex to collect anonymous usage statistics</label>
                </div>
            </div>
            <div id="${guid}listDiv">
                <div class="${guid}translate-header" style="height:42px; width:275px;">
                    <p id="${guid}select-title" class="${guid}translator-title" >Language Selection</p>
                </div>

                <div  class="${guid}search-container">
                    <input id="${guid}searchLanguage" type="search" class="${guid}form-control" placeholder="Search">
                </div>
                <div>
                    <ul id="${guid}fromListSelect" size="2" class="${guid}listSelect"></ul>
                    <ul id="${guid}toListSelect" size="2" class="${guid}listSelect"></ul>
                </div>
                <div id="${guid}btnCloseList" aria-hidden="true" title="Close">
                    <img class="${guid}close_btn" src="${browser.extension.getURL(
        'frame/Images/close.svg'
    )}"  alt="close button">
                </div>
            </div>
        </div>

        `;

    const smallModal = `



                <div class="${guid}init ${guid}position-center" id="${guid}toLangSelected" data-value="en_GB" data-name="ENGLISH">

                </div>



        <div class="${guid}lng_list_container">
            <div class="${guid}translate-header" style="height:42px; width:275px;">
                <p id="${guid}select-title" class="${guid}translator-title" >Language Selection</p>
            </div>
            <div  class="${guid}search-container">
                <input id="${guid}searchLanguage" type="search" class="${guid}small-lng-search ${guid}form-control" placeholder="Search">
            </div>
            <ul class="${guid}small-select-to ${guid}list-unstyled">
            </ul>
        </div>


            <span class="${guid}translatedText ${guid}position-center-left">

            </span>
             <img class="${guid}spinner-gif-small" src="${loader}" alt="spinner">

            <div class="${guid}icon-nav ${guid}position-center-space-between">
                <div class="${guid}speaker-icon-container ${guid}position-center">
                        <img src="${soundActive}" class="${guid}sound_activate" alt="play sound">
                        <img src="${soundInactive}" class="${guid}sound_inactive" alt="play sound">
                        <img src="${loader}" class="${guid}sound_loader" alt="loader">
                </div>
                <div class="${guid}bookmark-item-container ${guid}position-center">
                <svg xmlns="http://www.w3.org/2000/svg" width="22" height="21" viewBox="0 0 22 21" fill="none" class="c12b5a4e69860bc968b47223fd-disable-border c12b5a4e69860bc968b47223fd-red-svg c12b5a4e69860bc968b47223fd-bookmark-icon c12b5a4e69860bc968b47223fd-icon replaced-svg">
                <path d="M10.0469 2.00105C10.3422 1.0713 11.6578 1.07131 11.9531 2.00106L13.4288 6.64786C13.5615 7.06543 13.9505 7.34806 14.3886 7.34515L19.264 7.31273C20.2395 7.30625 20.646 8.55748 19.853 9.12562L15.8897 11.9651C15.5335 12.2202 15.3849 12.6775 15.5231 13.0933L17.0605 17.7201C17.3681 18.6458 16.3038 19.4191 15.5184 18.8405L11.5932 15.9486C11.2404 15.6887 10.7596 15.6887 10.4068 15.9486L6.48162 18.8405C5.69625 19.4191 4.63188 18.6458 4.93949 17.7201L6.4769 13.0933C6.61506 12.6775 6.46647 12.2202 6.11031 11.9651L2.14698 9.12562C1.35398 8.55749 1.76053 7.30625 2.73602 7.31273L7.61142 7.34515C8.04954 7.34806 8.43854 7.06544 8.57116 6.64786L10.0469 2.00105Z" stroke="#858E99" stroke-width="2"></path>
                </svg>
                </div>
                <div class="${guid}vocabulary-icon-container ${guid}position-center">
                    <svg xmlns="http://www.w3.org/2000/svg" width="30" height="30" viewBox="0 0 30 30" fill="none" class="c12b5a4e69860bc968b47223fd-vocabulary-icon c12b5a4e69860bc968b47223fd-red-svg c12b5a4e69860bc968b47223fd-icon replaced-svg">
                    <path d="M22.5 23.5C22.5 23.2239 22.2761 23 22 23C21.7239 23 21.5 23.2239 21.5 23.5H22.5ZM10 24.5C9.17157 24.5 8.5 23.8284 8.5 23H7.5C7.5 24.3807 8.61929 25.5 10 25.5V24.5ZM8.5 23C8.5 22.1716 9.17157 21.5 10 21.5V20.5C8.61929 20.5 7.5 21.6193 7.5 23H8.5ZM10 25.5H21.5V24.5H10V25.5ZM10 21.5H21.5V20.5H10V21.5ZM22.5 24.5V23.5H21.5V24.5H22.5ZM22.5 20.5V5.5H21.5V20.5H22.5ZM8.5 7C8.5 6.17157 9.17157 5.5 10 5.5V4.5C8.61929 4.5 7.5 5.61929 7.5 7H8.5ZM10 5.5H21.5V4.5H10V5.5ZM7.5 7V23H8.5V7H7.5ZM22.5 5.5C22.5 4.94771 22.0523 4.5 21.5 4.5V5.5H22.5ZM21.5 21.5C22.0523 21.5 22.5 21.0523 22.5 20.5H21.5V21.5ZM21.5 25.5C22.0523 25.5 22.5 25.0523 22.5 24.5H21.5V25.5Z" fill="#858E99"></path>
                    <path fill-rule="evenodd" clip-rule="evenodd" d="M8 21.5L11 21H22V5H9.82737L8 6V8V21.5ZM15.8846 8V9.73077H13V10.8846H14.7308C14.7309 12.0068 15.0869 13.0457 15.6921 13.8948C15.1099 14.4158 14.3757 14.7703 13.5643 14.8838L13.5548 14.853L13.5514 14.8419L13.5475 14.8311L12.4706 11.8311L11.5257 11.8419L9.52566 17.8419L10.4743 18.1581L10.8604 17H13.1692L13.5221 18.147L14.4779 17.853L13.9071 15.9978C14.8784 15.8267 15.7567 15.3855 16.4616 14.7546C17.3802 15.5768 18.5933 16.0767 19.9231 16.0767V14.9229C18.8889 14.9229 17.9455 14.5342 17.2311 13.8948C17.8363 13.0457 18.1923 12.0068 18.1923 10.8846H19.9231V9.73077H17.0385V8H15.8846ZM12.8615 16L12.6024 15.1581L12.0175 13.5286L11.1937 16H12.8615ZM17.0385 10.8846H16.4615H15.8847C15.8847 11.6459 16.0954 12.358 16.4616 12.9657C16.8278 12.358 17.0385 11.6459 17.0385 10.8846Z" fill="#858E99"></path>
                    </svg>
                </div>

            </div>

             <div style="display: none;" class="${guid}translate-small-div-bottom">
                <div class="${guid}dictionary-row" style="padding:0;display: block !important;">
                    <div class="${guid}form-control ${guid}id-lexical-meaning ${guid}dictionary-div">
                    </div>
                </div>
            </div>
    `;

    const translateContent = `
    <div id="${guid}translator-div-container" class="${guid}translator" style="display: none;">
        ${header}
        ${bigTranslateModal}
    </div>
    `;
    const smallTranslateModal = `
    <div style="display:none;" id="${guid}small-translator-div" class="lngx ${guid}small-translator-div">
        ${smallModal}
    </div>
    `;

    const mediumTranslateModal = `
            <div style="display:none;"  id="${guid}medium-translator-div" class="lngx" >
                    <div class="${guid}translate-medium-div-top">
                        <div class="${guid}etxensionLogo">
                             <img src=${browser.extension.getURL(
        'frame/Images/logo_text.png'
    )} class="${guid}logo_text" alt="logo with text">
                        </div>

                         <div class="${guid}init  ${guid}position-center" id="${guid}toLangSelected" data-value="en_GB" data-name="ENGLISH">

                        </div>


                         <div class="${guid}lng_list_container">
                            <div class="${guid}translate-header" style="height:42px; width:275px;">
                                <p id="${guid}select-title" class="${guid}translator-title" >Language Selection</p>
                            </div>
                            <div  class="${guid}search-container">
                                <input id="${guid}searchLanguage" type="search" class="${guid}small-lng-search ${guid}form-control" placeholder="Search">
                            </div>
                            <ul class="${guid}small-select-to ${guid}list-unstyled" >
                            </ul>
                         </div>

                         <span class="${guid}translatedText ${guid}position-center-left">


                          </span>
                          <img class="${guid}spinner-gif-medium" src="${loader}" alt="spinner">



                          <div class="${guid}icon-nav ${guid}position-center-space-between">
                            <div class="${guid}speaker-icon-container ${guid}position-center">
                                    <img src="${soundActive}" class="${guid}sound_activate" alt="play sound">
                                    <img src="${soundInactive}" class="${guid}sound_inactive" alt="play sound">
                                    <img src="${loader}" class="${guid}sound_loader" alt="loader">
                            </div>
                            <div class="${guid}bookmark-item-container ${guid}position-center">
                              <svg xmlns="http://www.w3.org/2000/svg" width="22" height="21" viewBox="0 0 22 21" fill="none" class="c12b5a4e69860bc968b47223fd-disable-border c12b5a4e69860bc968b47223fd-red-svg c12b5a4e69860bc968b47223fd-bookmark-icon c12b5a4e69860bc968b47223fd-icon replaced-svg">
                                <path d="M10.0469 2.00105C10.3422 1.0713 11.6578 1.07131 11.9531 2.00106L13.4288 6.64786C13.5615 7.06543 13.9505 7.34806 14.3886 7.34515L19.264 7.31273C20.2395 7.30625 20.646 8.55748 19.853 9.12562L15.8897 11.9651C15.5335 12.2202 15.3849 12.6775 15.5231 13.0933L17.0605 17.7201C17.3681 18.6458 16.3038 19.4191 15.5184 18.8405L11.5932 15.9486C11.2404 15.6887 10.7596 15.6887 10.4068 15.9486L6.48162 18.8405C5.69625 19.4191 4.63188 18.6458 4.93949 17.7201L6.4769 13.0933C6.61506 12.6775 6.46647 12.2202 6.11031 11.9651L2.14698 9.12562C1.35398 8.55749 1.76053 7.30625 2.73602 7.31273L7.61142 7.34515C8.04954 7.34806 8.43854 7.06544 8.57116 6.64786L10.0469 2.00105Z" stroke="#858E99" stroke-width="2"></path>
                                </svg>
                            </div>
                            <div style="cursor: pointer" class="${guid}settings-icon-container ${guid}position-center">
                               
                            <svg width="22px" height="22px" viewBox="0 0 22 22" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink">
                                <!-- Generator: Sketch 58 (84663) - https://sketch.com -->
                                <title>settings</title>
                                <desc>Created with Sketch.</desc>
                                <g id="Page-1" stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">
                                    <g id="settings" transform="translate(-1.000000, -1.000000)" fill="#858E99" fill-rule="nonzero">
                                        <path d="M10.7815,1.06608 C11.5835,0.97598 12.4006,0.97374 13.2184,1.06527 C13.8034,1.13072 14.1258,1.75323 14.2694,2.32402 C14.4184,2.91667 14.8361,3.4337 15.4441,3.68552 C16.0521,3.93735 16.7131,3.86715 17.2375,3.55347 C17.7426,3.25136 18.4108,3.03919 18.8707,3.4065 C19.5137,3.9201 20.0899,4.49942 20.5933,5.13027 C20.9604,5.59025 20.7485,6.2583 20.4466,6.7635 C20.1332,7.2878 20.0631,7.9486 20.3149,8.5563 C20.5437182,9.10875455 20.9915446,9.5041843 21.5161554,9.68361104 L21.6757,9.7309 C22.2463,9.8746 22.8686,10.1972 22.9343,10.782 C23.0244,11.584 23.0266,12.4011 22.9351,13.2189 C22.8697,13.8038 22.2472,14.1263 21.6764,14.2698 C21.0837,14.4189 20.5667,14.8366 20.3149,15.4446 C20.063,16.0526 20.1332,16.7136 20.4469,17.238 C20.749,17.7431 20.9612,18.4113 20.5939,18.8712 C20.0803,19.5142 19.501,20.0904 18.8701,20.5938 C18.4454846,20.9326615 17.8435533,20.778174 17.3561861,20.514949 L17.2369,20.4471 C16.7125,20.1337 16.0518,20.0636 15.4441,20.3154 C14.8364,20.5671 14.4187,21.0838 14.2695,21.6762 C14.1258,22.2468 13.8032,22.8691 13.2184,22.9348 C12.4164,23.0249 11.5993,23.0271 10.7815,22.9356 C10.1965,22.8702 9.8741,22.2477 9.7305,21.6769 C9.5815,21.0842 9.1638,20.5672 8.5558,20.3154 C8.00307273,20.0864 7.4065438,20.1235983 6.90866251,20.3679417 L6.7624,20.4474 C6.2573,20.7495 5.5891,20.9617 5.12922,20.5944 C4.48619,20.0808 3.91003,19.5015 3.40661,18.8706 C3.03955,18.4106 3.25145,17.7425 3.55335,17.2374 C3.86672,16.7131 3.93676,16.0523 3.68503,15.4446 C3.45619364,14.8921455 3.00834074,14.4967157 2.48375532,14.317289 L2.32422,14.27 C1.75355,14.1263 1.1313,13.8037 1.0656,13.2189 C0.97549,12.4169 0.97325,11.5998 1.06478,10.782 C1.13023,10.197 1.75274,9.8746 2.32353,9.731 C2.91618,9.582 3.43321,9.1642 3.68503,8.5563 C3.91396636,8.00357273 3.87676223,7.4070438 3.63243338,6.90916251 L3.55298,6.7629 C3.25086,6.2578 3.0387,5.58959 3.40601,5.12971 C3.9196,4.48668 4.49892,3.91051 5.12978,3.40709 C5.58976,3.04003 6.2579,3.25194 6.763,3.55384 C7.2874,3.86721 7.9481,3.93726 8.5558,3.68553 C9.1635,3.4338 9.5812,2.91707 9.7304,2.32471 C9.8741,1.75404 10.1967,1.13178 10.7815,1.06608 Z M12,8 C9.7909,8 8,9.7909 8,12 C8,14.2091 9.7909,16 12,16 C14.2091,16 16,14.2091 16,12 C16,9.7909 14.2091,8 12,8 Z" id="Shape"></path>
                                    </g>
                                </g>
                            </svg>
                            </div>
                        </div>



                            <div class="${guid}moreAplacationText">
                                <a target="_blank" href="#" class="${guid}add-link"><img class="${guid}add-img"  src='#'/>
                                    <span>More translation applications</span>
                                </a>
                            </div>
                    </div>

            </div>
        `;
    //add modals html code to the page


    $('body:not(.popup-container)').append(
        `
          <canvas id="ocrext-canOrig" class="ocrext-element" width="480" height="320" style="display: none;"></canvas>
        `,
        translateIcon,
        translateContent,
        mediumTranslateModal,
        smallTranslateModal
    );

    $('#popup-container').append(translateContent);
});
